module(..., package.seeall)

--local lumiiRep = "lua_mii_rep"
--local lQuery = require "lQuery"
local queryExecution = require ("Endpoint.conect_SPARQL")
local url = require("socket.url")
export = require ("Endpoint.Export_Onto")
local namedGraph = ""

--We make an assumption that literal values can be only saw in range

local function localname (uri) --no uri atgriez: localName
	local t = url.parse(uri)
	local localname = t.fragment
	if t.fragment == nil then
		local path = url.parse_path(t.path)
		local nr = # path --find how many subpaths
		if nr > 0 then
			localname = path[nr]
		else
			localname = ""
		end
	end
	return localname
end

local function namespace (uri) --no uri atgriez: namespace
	local localname = localname(uri)
	local locallen = string.len(localname)
	local urilen = string.len (uri)
	local namespace = string.sub(uri, 1, urilen - locallen)
	return namespace
end

local function assoc_name_and_type(sparql_endpoint, uri)
	query = [[
	select ?type ?name ]].. namedGraph .. [[ where {
	OPTIONAL {<]] .. uri .. [[> a ?type }
	OPTIONAL {<]] .. uri .. [[> <http://www.w3.org/2000/01/rdf-schema#label> ?name }}]]

	local available = queryExecution.execute_query (sparql_endpoint, query)
	--parbaudam vai vaicajums korekti strada
	if available then
		tips = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell[name = type]"):attr("value")
		name = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell[name = name]"):attr("value")
		if name == nil then
			name = localname(uri)
		end
		if tips == nil then
			tips = "NA"
		end
		return name, tips
	end
	return localname(uri), "NA"
end

local function attr_name_and_type(sparql_endpoint, uri)
	query = [[
	select ?type ?name ]].. namedGraph .. [[ where {
	OPTIONAL {<]] .. uri .. [[> <http://www.w3.org/2000/01/rdf-schema#range> ?type }
	OPTIONAL {<]] .. uri .. [[> <http://www.w3.org/2000/01/rdf-schema#label> ?name }}]]

	local available = queryExecution.execute_query (sparql_endpoint, query)
	--parbaudam vai vaicajums korekti strada
	if available then
		tips = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell[name = type]"):attr("value")
		name = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell[name = name]"):attr("value")
		if name == nil then
			name = localname(uri)
		end
		if tips == nil then
			tips = "NA"
		end
		return name, tips
	end
	return localname(uri), "NA"
end

local function class_name(sparql_endpoint, uri)
	query = [[
	select ?name ]].. namedGraph .. [[ where {
	OPTIONAL {<]] .. uri .. [[> a ?type }
	OPTIONAL {<]] .. uri .. [[> <http://www.w3.org/2000/01/rdf-schema#label> ?name }
	FILTER ((?type != <http://www.w3.org/2002/07/owl#Class> && ?type != <http://www.w3.org/2002/07/owl#DeprecatedClass>) || !bound(?type))
	}]]

	local available = queryExecution.execute_query (sparql_endpoint, query)
	--parbaudam vai vaicajums korekti strada
	if available then
		--tips = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/cell[name = type]"):attr("value")
		name = lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell"):filter_attr_value_equals("name", "name"):first():attr("value")
		--print (lQuery("Query#Query"):filter_attr_value_equals("query", query):find("/row/cell"):is_empty())
		if name == nil then
			return localname(uri)
		end
		return name
	end
	return localname(uri)
end

local function classParse(tips, class_query, sparql_endpoint, short) --sanem klases tipu un vaicajumu ar mainigajiem classuri, classname, izveido Onto#Class instances
	local vaic = lQuery("Query#Query"):filter_attr_value_equals("query", class_query)
	vaic:find("/row"):each(
		function (row)
			uris = row:find("/cell[name = classuri]"):attr("value")
			if short == true then
				name = class_name (sparql_endpoint, uris)
			else
				name = row:find("/cell[name = classname]"):attr("value")
				if name == nil then
					name = localname(uris)
				end
			end
			local namespaces = namespace(uris)
			--parbauda vai tas nav klases, ko izmanto tehniskam vajadzibam
			if namespaces ~= "http://www.w3.org/2002/07/owl#" and namespaces ~= "http://www.openlinksw.com/schemas/virtrdf#" then
				klase = lQuery.create("Onto#Class" ,
					{URI = uris,
					namespace = namespace(uris),
					localname = localname(uris),
					type = tips,
					name = name
					}
				)
				--print ("Create class " .. uris)
			end
		end
	)
	queryExecution.delete_query ()
end

local function class_spy(sparql_endpoint) --Iegust OwlClass, DeprecatedClass un Typed klases atbilstosi vaicajumiem
--izspiegojam klases, kas ir definetas ar OWL:Class
	local class_query = [[
	select distinct ?classuri ?classname
	 ]].. namedGraph .. [[ where {
	?classuri a <http://www.w3.org/2002/07/owl#Class>.
	OPTIONAL {?classuri <http://www.w3.org/2000/01/rdf-schema#label> ?classname}}

	]]

	local available = queryExecution.execute_query (sparql_endpoint, class_query)
	--parbaudam vai vaicajums korekti strada
	if available then
		classParse("Ontology", class_query)
	end

--izspiegojam klases, kas ir definetas ar OWL:DeprecatedClass
	local class_query = [[
	select distinct ?classuri ?classname
	 ]].. namedGraph .. [[ where {
	?classuri a <http://www.w3.org/2002/07/owl#DeprecatedClass>.
	OPTIONAL {?classuri <http://www.w3.org/2000/01/rdf-schema#label> ?classname}}

	]]

	local available = queryExecution.execute_query (sparql_endpoint, class_query)
	--parbaudam vai vaicajums korekti strada
	if available then
		classParse("Deprecated", class_query)
	end

	--ar vienu vaicajumu
	local class_query = [[
	select distinct ?classuri ?classname
	 ]].. namedGraph .. [[ where {
	?x a ?classuri.
	OPTIONAL {?classuri a ?type }
	OPTIONAL {?classuri <http://www.w3.org/2000/01/rdf-schema#label> ?classname }
	FILTER ((?type != <http://www.w3.org/2002/07/owl#Class> && ?type != <http://www.w3.org/2002/07/owl#DeprecatedClass>) || !bound(?type))
	}
	]]


	local available = queryExecution.execute_query (sparql_endpoint, class_query)
	if available then
		local short = false --apzime vai attr name un type vajag meklet atseviski
		classParse("Typed", class_query, sparql_endpoint, short)
	else
	local class_query_short = [[
		select distinct ?classuri
		 ]].. namedGraph .. [[ where {
		?x a ?classuri.
		}
		]]
		local available_short = queryExecution.execute_query (sparql_endpoint, class_query_short)
		if available_short then
			local short = true
			classParse("Typed", class_query_short, sparql_endpoint, short)
		end
	end

end

local function QueryClassObjectCount() --aizpilda Onto#Class ar to, cik katrai klasei ir objektu instances
	--izveidojam instancu skaitu klasem
	lQuery("Onto#Class"):each(
		function(klase)
			local skaits = 	 [[
				select  count distinct (?t)
				 ]].. namedGraph .. [[ where {
				?t a <]] .. klase:attr("URI") .. [[>}
				]]
			local count = queryExecution.execute_query (sparql_endpoint, skaits)
			if count then
				--print(lQuery("Query#Query/row/cell"):attr("value"))
				instSkaits = lQuery("Query#Query/row/cell"):attr("value")
				--print(klase:attr("name"))
				klase:attr({instanceCount = instSkaits})
			end
			--print(klase:attr("name"))
			--print(klase:attr("URI"))
			queryExecution.delete_query ()
		end
		)
end

local function QueryAssocObjectCount() --Onto#Association ar to, cik katrai relacijai ir instances (neatkarigi no klasem, ko savieno)
	--izveidojam instancu skaitu associacijam
	lQuery("Onto#Association"):each(
		function(assoc)
			local skaits = 	 [[
				select count distinct ?a ?b
				 ]].. namedGraph .. [[ where {
				?a <]] .. assoc:attr("URI") .. [[> ?b}
				]]
			local count = queryExecution.execute_query (sparql_endpoint, skaits)
			if count then
				--print(lQuery("Query#Query/row/cell"):attr("value"))
				instSkaits = lQuery("Query#Query/row/cell"):attr("value")
				--print(klase:attr("name"))
				assoc:attr({instanceCount = instSkaits})
			end
			--print(klase:attr("name"))
			--print(klase:attr("URI"))
			queryExecution.delete_query ()
		end
		)
end
local function subClassRelations(sparql_endpoint) --visam definetajam klasem mekle virsklases
	--izveidojam instancu skaitu klasem
	lQuery("Onto#Class"):each(
		function(klase)
			local skaits = 	 [[
				select distinct ?a
				 ]].. namedGraph .. [[ where {
				<]] .. klase:attr("URI") .. [[> <http://www.w3.org/2000/01/rdf-schema#subClassOf> ?a.
				}
				]]
			local count = queryExecution.execute_query (sparql_endpoint, skaits)
			if count then
				--print(lQuery("Query#Query/row/cell"):attr("value"))
				lQuery("Query#Query/row/cell"):each(
					function (suriobj)
						suri = suriobj:attr("value")
						supKlase = lQuery("Onto#Class"):find("[URI = " .. suri .. "]")
						supKlase:link("subClass", klase)
						kuri = klase:attr("URI")
						--print (suri .. " zem " .. kuri)
					end
				)
				--instSkaits = lQuery("Query#Query/row/cell"):attr("value")
				--print(klase:attr("name"))
				--klase:attr({instanceCount = instSkaits})
			end
			--print(klase:attr("name"))
			--print(klase:attr("URI"))
			queryExecution.delete_query ()
		end
		)
end

local function assocLinkRange (sparql_endpoint, assoc)
	local rangeGals = 	 [[
		select distinct ?rangeClass
		 ]].. namedGraph .. [[ where {
		?obj2 a ?rangeClass.
		?obj <]] .. assoc:attr("URI") .. [[> ?obj2}
		]]
	local isClass = queryExecution.execute_query (sparql_endpoint, rangeGals)
	if isClass then
		klasuListe = lQuery("Query#Query"):filter_attr_value_equals("query", rangeGals):find("/row/cell")
		klasuListe:each(
			function (classCell)
				local classUri = classCell:attr("value")
				--print(classUri)
				--ja klase ir no OWL vai RDF sistemas, tad neko nedara
				if classUri == "http://www.w3.org/2002/07/owl#Thing" or (namespace(classUri) ~= "http://www.w3.org/2002/07/owl#" and namespace(classUri) ~= "http://www.openlinksw.com/schemas/virtrdf#") then
					rClass = lQuery("Onto#Class"):filter_attr_value_equals("URI", classUri)
					if rClass:is_empty() then
						rClass = lQuery.create("Onto#Class" ,
						{URI = classUri,
						namespace = namespace(classUri),
						localname = localname(classUri),
						type = "Typed",
						name = localname(classUri)
						})
						print ("Create class" .. classUri)
					end
					assoc:link("range", rClass)
				end
				--print (assoc:attr("name") .. " range " .. rClass:attr("name"))
			end
		)
		if klasuListe:is_empty() then
			assoc:link ("range", thing)
		end
	end
	if not isClass then
		assoc:link ("range", thing)
	end
	--queryExecution.delete_query ()
end

local function AssocParse(tips, class_query, sparql_endpoint, dClass)
	local vaic = lQuery("Query#Query"):filter_attr_value_equals("query", class_query):find("/row"):each(
		function (row)
			uris = row:find("/cell[name = assocuri]"):attr("value")
			name = row:find("/cell[name = assocname]"):attr("value")
			if name == nil then
				name = localname(uris)
			end
			--print (uris)
			findAssoc = lQuery("Onto#Association"):find("[URI = ".. uris .. "]")
			--print (findAssoc)
			if findAssoc:is_empty() then
				--print (uris)
				assoc = lQuery.create("Onto#Association" ,
					{URI = uris,
					namespace = namespace(uris),
					localname = localname(uris),
					type = tips,
					name = name
					}
				)
				if dClass ~= nil and assoc:has_link_to_all("domain", dClass):is_empty() then --gadijuma, ja apskatam 2. associaciju pievienosanas variantu, tad pievienojam ari domena klasi
					--print ("dom link" .. dClass:attr("name"))
					assoc:link("domain", dClass)
				end
				assocLinkRange (sparql_endpoint, assoc)
			end
		end
	)
end

local function AssocObjParse(class_query, sparql_endpoint)
	local vaic = lQuery("Query#Query"):filter_attr_value_equals("query", class_query):find("/row"):each(
		function (row)
			uris = row:find("/cell[name = assocuri]"):attr("value")
			--varam meklet atseviski name un type, paatrina vaicajuma izpildi, tacu kopa izpildas lenak
			--name, tips = assoc_name_and_type(sparql_endpoint, uris)
			name = row:find("/cell[name = name]"):attr("value")
			if name == nil then
				name = localname(uris)
			end
			tips = row:find("/cell[name = tips]"):attr("value")
			if tips == nil then
				tips = "NA"
			end
			--parbaudam vai ta ir associacija, jo otra gala butu jabut objektam, no kura kaut kas iziet
			local test_assoc_query = [[
			select distinct ?obj1
			 ]].. namedGraph .. [[ where {
			?obj1 <]] ..uris ..[[> ?obj2.
			?obj2 ?attr ?value}
			LIMIT 1
			]]
			local available = queryExecution.execute_query (sparql_endpoint, test_assoc_query)
			if available and not lQuery("Query#Query"):filter_attr_value_equals("query", test_assoc_query):find("/row/cell[name = obj1]"):is_empty() then
				--print (uris)
				irAssoc = lQuery("Onto#Association"):filter_attr_value_equals("URI", uris)
				if (irAssoc:is_empty()) and (tips ~= "http://www.w3.org/2002/07/owl#ObjectProperty" or tips ~= "http://www.w3.org/2002/07/owl#DatatypeProperty") and (namespace(uris)~= "http://www.openlinksw.com/schemas/virtrdf#") then
					assoc = lQuery.create("Onto#Association" ,
						{URI = uris,
						namespace = namespace(uris),
						localname = localname(uris),
						type = tips,
						name = name
						}
					)
					assocLinkRange (sparql_endpoint, assoc)
				end
			end
		end
	)
end

local function assocDomainEnd(sparql_endpoint)
	local thing = lQuery("Onto#Class"):find("[URI = http://www.w3.org/2002/07/owl#Thing]")

	--panemam visas asociacijas un atrodam klases, kas atrodas galos
	lQuery("Onto#Association"):each(
		function(assoc)
			local domGals = 	 [[
				select distinct ?domainClass
				 ]].. namedGraph .. [[ where {
				?obj a ?domainClass.
				?obj <]] .. assoc:attr("URI") .. [[> ?obj2}
				]]
			local isClass = queryExecution.execute_query (sparql_endpoint, domGals)
			if isClass then
				lQuery("Query#Query"):filter_attr_value_equals("query",  domGals):find("/row/cell"):each(
					function (classCell)
						local classUri = classCell:attr("value")
						dClass = lQuery("Onto#Class"):filter_attr_value_equals("URI",  classUri):first()
						assoc:link("domain", dClass)
					end
				)
				if lQuery("Query#Query"):filter_attr_value_equals("query",  domGals):find("/row/cell"):is_empty() then
					assoc:link ("domain", thing)
				end
			end
			if not isClass then
				assoc:link ("domain", thing)
			end
			queryExecution.delete_query ()
			--assocLinkRange (assoc)
		end
		)

end

local function assocSpy(sparql_endpoint) --iegustam definetas owl associacijas, associacijas, kas saista divus IRI objektus (ja neizpildas, tad mekle asociacijas, kam viena gala ir klase)
	--iegustam definetas associacijas, kuram ir kada instance
	local assoc_query = [[
	select distinct ?assocuri ?assocname
	 ]].. namedGraph .. [[ where {
	?assocuri a <http://www.w3.org/2002/07/owl#ObjectProperty>.
	OPTIONAL {?assocuri <http://www.w3.org/2000/01/rdf-schema#label> ?assocname }
	}
	]]

	--could select assoc with at least one instance
	--[[
	select distinct ?assocuri ?assocname
	where {
	?assocuri a <http://www.w3.org/2002/07/owl#ObjectProperty>.
	?obj1 ?assocuri ?obj2.
	OPTIONAL {?assocuri <http://www.w3.org/2000/01/rdf-schema#label> ?assocname }
	}
	]]

	local thing = lQuery("Onto#Class"):find("[URI = http://www.w3.org/2002/07/owl#Thing]")

	local available = queryExecution.execute_query (sparql_endpoint, assoc_query)
	--parbaudam vai vaicajums korekti strada
	if available then
		AssocParse("Ontology", assoc_query, sparql_endpoint, nil)
	end
	queryExecution.delete_query ()

	local assoc_query = [[
	select distinct ?assocuri ?type ?name
	 ]].. namedGraph .. [[ where {
	?obj1 ?assocuri ?obj2.
	OPTIONAL {?assocuri a ?type }
	OPTIONAL {?assocuri <http://www.w3.org/2000/01/rdf-schema#label> ?name }
	FILTER (isiri(?obj1) && isiri(?obj2))
	}
	]]

	local availableAssocs = queryExecution.execute_query (sparql_endpoint, assoc_query)
	--parbaudam vai vaicajums korekti strada
	if availableAssocs then
		AssocObjParse(assoc_query, sparql_endpoint)
	end
	queryExecution.delete_query ()

	assocDomainEnd(sparql_endpoint)

	if not availableAssocs then
		--iespejams, nav atrastas associacijas, jo parak ilgi izpildas
		lQuery("Onto#Class"):each(
			function (dClass)
				local findAssoc = [[
				select distinct ?assocuri ?assocname
				 ]].. namedGraph .. [[ where{
				?obj a ?dClass.
				?obj ?assocuri ?obj2.
				OPTIONAL {?assocuri <http://www.w3.org/2000/01/rdf-schema#label> ?assocname }
				]]
				local tips = "Typed"
				AssocParse(tips, findAssoc, sparql_endpoint, dClass)
			end
		)
	end



end

local function attributeParse(attr_query, class, sparql_endpoint, short, toThing)
	lQuery("Query#Query"):filter_attr_value_equals("query", attr_query):find("/row"):each(
		function (row)
			uris = row:find("/cell[name = attrUri]"):attr("value")
			findAssoc = lQuery("Onto#Association"):find("[URI = ".. uris .. "]") --meklejam vai jau nav elements ar tadu URI
			--parbaudam vai ta gadijuma nav associacija, nevis atributs
			if findAssoc:is_empty() and uris ~= "http://www.w3.org/1999/02/22-rdf-syntax-ns#type" then
				if short == true then
					--varam meklet ar vairakiem vaicajumiem, ja nonemam optional, katrs ir atrak, bet kopa lenak
					name, tips = attr_name_and_type(sparql_endpoint, uris)
				else
					name = row:find("/cell[name = name]"):attr("value")
					if name == nil then
						name = localname(uris)
					end
					tips = row:find("/cell[name = tips]"):attr("value")
					if tips == nil then
						tips = "NA"
					end
				end
				findAttr = lQuery("Onto#Attribute"):find("[URI = ".. uris .. "]")
				if findAttr:is_empty() and toThing == false then
					attributes = lQuery.create("Onto#Attribute" ,
						{URI = uris,
						namespace = namespace(uris),
						localname = localname(uris),
						type = attrTips,
						name = name
						}
					)
					class:link("attribute", attributes)
				elseif toThing == false then
					class:link("attribute", findAttr)
				elseif findAttr:is_empty() and toThing == true then
					thing = lQuery("Onto#Class[URI = http://www.w3.org/2002/07/owl#Thing]")
					attributes = lQuery.create("Onto#Attribute" ,
						{URI = uris,
						namespace = namespace(uris),
						localname = localname(uris),
						type = attrTips,
						name = name
						}
					)
					thing:link("attribute", attributes)
				end
			end
		end
	)
end
local function attributeSpy(sparql_endpoint) --iegustam definetos atributus
	queryExecution.delete_query ()
	--katrai klasei atlasam atributus
	lQuery("Onto#Class"):each(
	function(class)
		local attr_query = [[
		select distinct ?attrUri ?tips ?name
		 ]].. namedGraph .. [[ where { ?obj a <]] .. class:attr("URI") .. [[>.
		?obj ?attrUri ?value.
		OPTIONAL {?attrUri <http://www.w3.org/2000/01/rdf-schema#range> ?type }
		OPTIONAL {?attrUri <http://www.w3.org/2000/01/rdf-schema#label> ?name }
		}
		]]
		local available = queryExecution.execute_query (sparql_endpoint, attr_query)
		if available then
			local short = false --apzime vai attr name un type vajag meklet atseviski
			local toThing = false
			attributeParse(attr_query, class, sparql_endpoint, short, toThing)
		else
		local attr_query_short = [[
			select distinct ?attrUri
			 ]].. namedGraph .. [[ where { ?obj a <]] .. class:attr("URI") .. [[>.
			?obj ?attrUri ?value.
			}
			]]
			local available_short = queryExecution.execute_query (sparql_endpoint, attr_query_short)
			if available_short then
				local short = true
				local toThing = false
				attributeParse(attr_query_short, class, sparql_endpoint, short, toThing)
			end
		end
	end)

	queryExecution.delete_query ()
	local all_attr_query = [[
	select distinct ?attrUri ?name ?type
	 ]].. namedGraph .. [[ where {
	?obj1 ?attrUri ?obj2.
	OPTIONAL {?attrUri <http://www.w3.org/2000/01/rdf-schema#range> ?type }
	OPTIONAL {?attrUri <http://www.w3.org/2000/01/rdf-schema#label> ?name }
	FILTER (isLiteral(?obj2))
	}
	]]

	local available = queryExecution.execute_query (sparql_endpoint, all_attr_query)
	if available then
		local short = false --apzime vai attr name un type vajag meklet atseviski
		local toThing = true --apzime ka atributi japievieno Thing klasei, ja tie vel nav
		attributeParse(all_attr_query, class, sparql_endpoint, short, toThing)
	end

--atlasam visus definetos atributus
--	local attr_query = [[
--[[	select distinct
	?attrType ?attrUri ?attrName
	where {
	?attrUri a <http://www.w3.org/2002/07/owl#DatatypeProperty>.
	OPTIONAL { ?attrUri <http://www.w3.org/2000/01/rdf-schema#label> ?attrName }
	OPTIONAL {?attrUri <http://www.w3.org/2000/01/rdf-schema#range> ?attrType }}
	]]

	queryExecution.delete_query ()
	--local available = queryExecution.execute_query (sparql_endpoint, attr_query)



end
function spy_endpoint(sparql_endpoint, namedGraphInput)
	if namedGraphInput ~= "" then
		namedGraph = "FROM <" .. namedGraphInput .. ">"
	end
	local test_query = "select ?x where {?a ?b ?x} limit 1"
	--parbaudm vai SPARQL endpoint var iestt vispr vaicjumus
	print (test_query)
	local available = queryExecution.execute_query (sparql_endpoint, test_query)
	if not available then
		print ("Error - could not connect to endpoint:" .. sparql_endpoint)
		return false
	end
	--test also if there is named graph
	if namedGraphInput ~= "" then
		local test_query = "select ?x " .. namedGraph .." where {?a ?b ?x} limit 1"
		--parbaudm vai SPARQL endpoint var iestt vispr vaicjumus
		print (test_query)
		local available = queryExecution.execute_query (sparql_endpoint, test_query)
		if not available then
			print ("No instances in named graph:" .. namedGraphInput)
			return false
		end	
	end
	
	print ("Connection succesful!")
	queryExecution.delete_query ()

	--izspiegojam ontologija esosas klases
	class_spy(sparql_endpoint)

	--vajag pievienot owl:Thing, kas ir virsklase parejam klasem
	thing = lQuery("Onto#Class[URI = http://www.w3.org/2002/07/owl#Thing]")

	if thing:is_empty() then
		thing = lQuery.create("Onto#Class",	{
			URI = "http://www.w3.org/2002/07/owl#Thing",
			namespace = "http://www.w3.org/2002/07/owl#",
			localname = "Thing",
			name = "Thing",
			type = "Thing"
		})
		print ("Create Thing")
	end
	--print("Thing" .. thing:attr("name"))
	--pievienojam, ka Thing ir parejam klasem virsklase
--	lQuery("Onto#Class"):each(
--	function(obj)
--		obj:link("superClass", thing)
--	end)
--	thing:remove_link("superClass", thing)

	assocSpy(sparql_endpoint)

	--print ("Attributes")
	attributeSpy(sparql_endpoint)

	--export.export()

	--QueryClassObjectCount()
	--QueryAssocObjectCount()
	subClassRelations(sparql_endpoint)

	--associacijas, kuram nevareja atrast range vai domain ir sastatnes, kuras nevajadzetu attelot
	lQuery("Onto#Association"):each(
		function(obj)
			if obj:find("/domain"):is_empty() or obj:find("/range"):is_empty()	then
				obj:delete()
			end
		end
		)

--[[		lQuery("Onto#Association"):each(
		function(obj)
			print(obj:attr("name") .. " " .. obj:attr("URI"))
			--print(obj:attr("instanceCount"))
			local domains = "Domains: "
			obj:find("/domain"):each(
				function (obj1)
					domains = domains .. " " .. obj1:attr("name")
					--print(obj1:attr("name"))
				end
				)
			print (domains)
			local ranges = "Ranges: "
			obj:find("/range"):each(
				function (obj1)
					ranges = ranges .. " " .. obj1:attr("name")
					--print(obj1:attr("name"))
				end
				)
			print (ranges)
			--print ("END")
			obj:delete()
		end)

		lQuery("Onto#Class"):each(
		function(obj)
			print(obj:attr("name") .. " " .. obj:attr("URI"))
			--print(obj:attr("instanceCount"))
			local attributes = "Attributes: "
			obj:find("/attribute"):each(
				function (obj1)
					attributes = attributes .. ", " .. obj1:attr("name")
					--print(obj1:attr("name"))
				end
			)
			print (attributes)
			obj:delete()
		end)

--]]

end

function delete_onto()

		lQuery("Onto#Element"):each(
		function(obj)
			obj:delete()
		end)

end


