module(..., package.seeall)

utilities = require("utilities")
dialog = require("dialog_utilities")
transformations = require("transformations")
--t = require("interpreter.tree")

local aggregateInQuery
local aggregationCount 
local collection
local prefixTable = {}
local attributesNamesTablePrevious = {}
local idTable = {}
local isFunctionGlobal = false
local aggregateGlobal = false

function getURI(ontoElemType, name)
	local uri = ""
	if name ~= nil and name ~= "" then
		local namespace = lQuery(ontoElemType .. "[name='" .. name .. "']"):attr("namespace")
		if namespace~= nil then
			if lQuery("Onto#Prefix[fullForm='" .. namespace .. "']"):is_not_empty() and lQuery("Onto#Prefix[fullForm='" .. namespace .. "']"):attr("shortForm")~= "??" then
				uri = lQuery("Onto#Prefix[fullForm='" .. namespace .. "']"):attr("shortForm") .. name
				prefixTable[lQuery("Onto#Prefix[fullForm='" .. namespace .. "']"):attr("shortForm")] = namespace
			else
				uri = "<" .. lQuery(ontoElemType .. "[name='" .. name .. "']"):attr("URI") .. ">"
			end
		end
	end
	return uri
end

function notSupportedtSPARQL()

  local close_button = lQuery.create("D#Button", {
    caption = "Close"
    ,eventHandler = utilities.d_handler("Click", "lua_engine", "lua.generate_SPARQL.close()")
  })
  
  local form = lQuery.create("D#Form", {
    id = "incorrectSyntax"
    ,caption = " "
    ,buttonClickOnClose = false
    ,cancelButton = close_button
    ,defaultButton = close_button
    ,eventHandler = utilities.d_handler("Close", "lua_engine", "lua.generate_SPARQL.close()")
    ,minimumWidth = 410
	,component = {
		lQuery.create("D#HorizontalBox",{
			component = {
				lQuery.create("D#VerticalBox",{
					component = {
						lQuery.create("D#Label", {caption = "Query structure not supported in this version"})
					}
				})
			}})
		,lQuery.create("D#HorizontalBox", {
			horizontalAlignment = 1
			,component = {close_button}
		})
    }
  })
  dialog_utilities.show_form(form)

end

function incorrectSPARQL()

  local close_button = lQuery.create("D#Button", {
    caption = "Close"
    ,eventHandler = utilities.d_handler("Click", "lua_engine", "lua.generate_SPARQL.close()")
  })
  
  local form = lQuery.create("D#Form", {
    id = "incorrectSyntax"
    ,caption = "Incorrect graphical query"
    ,buttonClickOnClose = false
    ,cancelButton = close_button
    ,defaultButton = close_button
    ,eventHandler = utilities.d_handler("Close", "lua_engine", "lua.generate_SPARQL.close()")
    ,minimumWidth = 410
	,component = {
		lQuery.create("D#HorizontalBox",{
			component = {
				lQuery.create("D#VerticalBox",{
					component = {
						lQuery.create("D#Label", {caption = "Incorrect graphical query."})
						,lQuery.create("D#Label", {caption = "Please check graphical query."})
					}
				})
			}})
		,lQuery.create("D#HorizontalBox", {
			horizontalAlignment = 1
			,component = {close_button}
		})
    }
  })
  dialog_utilities.show_form(form)

end

function close()
	lQuery("D#Event"):delete()
	utilities.close_form("incorrectSyntax")
end


function next_elem2(edge, element, path, linkType)

	local notAggregateAttrList = ""
	local join = ""
	local filter = ""
	local selection = ""
	
	local baseSelectTable = {}
	
	if edge:attr("visited") == 'false' then
		edge:attr("visited", 'true')
		elem = edge:find(path)
		-- if collection~="" then 
			if diagram:find(collection .. "/element"):filter(function(e) return e:id() == elem:id() end):is_not_empty() then
				-- local name = element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
				local name = idTable[element:id()]
				if name == "" or name == nil then name = element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") end
				-- local name1 = elem:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
				local name1 = idTable[elem:id()]
				if name1 == "" or name1 == nil then name1 = elem:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") end
				-- local linkURI = lQuery("Onto#AllAssociation[name='" .. edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") .. "']"):attr("URI")
				
				local nameURI = getURI("Onto#Class", element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") )
				local name1URI = getURI("Onto#Class", elem:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") )

				local linkURI = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
				-- if linkURI ~= nil and linkURI ~= "" and nameURI~="" and name1URI~="" then 
				if linkURI ~= nil and linkURI ~= ""  then 
					if path == "/end" then
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name1 .. " " .. linkURI .. " ?" .. name .. ".\n"
						else
							join = "?" .. name .. " " .. linkURI .. " ?" .. name1 .. ".\n"
						end
					else
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name .. " " .. linkURI .. " ?" .. name1 .. ".\n"
						else
							join = "?" .. name1 .. " " .. linkURI .. " ?" .. name .. ".\n"
						end
					end
				-- elseif string.sub(elem:find("/compartment:has(/compartType[id = 'Name'])"):attr("value"), 1, 1) == "?" and nameURI~="" and name1URI~="" then
				elseif string.sub(edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value"), 1, 1) == "?"  then
					local linkName = edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
					if path == "/end" then
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name1 .. " " .. linkName .. " ?" .. name .. ".\n"
						else
							join = "?" .. name .. " " .. linkName .. " ?" .. name1 .. ".\n"
						end
					else
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name .. " " .. linkName .. " ?" .. name1 .. ".\n"
						else
							join = "?" .. name1 .. " " .. linkName .. " ?" .. name .. ".\n"
						end
					end
				elseif string.find(edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value"), ":") ~= nil then
					local linkName = edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
					
					if lQuery("Onto#Prefix[shortForm='" .. string.sub(linkName,1, string.find(linkName, ":")) .. "']"):is_not_empty() then
						prefixTable[string.sub(linkName,1, string.find(linkName, ":"))] = lQuery("Onto#Prefix[shortForm='" .. string.sub(linkName,1, string.find(linkName, ":")) .. "']"):attr("fullForm")
					end
					
					if path == "/end" then
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name1 .. " " .. linkName .. " ?" .. name .. ".\n"
						else
							join = "?" .. name .. " " .. linkName .. " ?" .. name1 .. ".\n"
						end
					else
						local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
						if inv == "true" then
						   join = "?" .. name .. " " .. linkName .. " ?" .. name1 .. ".\n"
						else
							join = "?" .. name1 .. " " .. linkName .. " ?" .. name .. ".\n"
						end
					end
				end

				baseSelectTable  = check2 (elem, element, linkType)
				
				if baseSelectTable == "" then incorrectSPARQL() 
				else
					baseSelectTable["link"] = join
					baseSelectTable["linkType"] = "Link"
					local t = {}
					t[name1]=baseSelectTable
	
					if string.sub(edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value"), 1, 1) == "?"  then
						-- baseSelectTable["selectAttributesMain"] = baseSelectTable["selectAttributesMain"] .. " " .. edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
						baseSelectTable["selectAttributesMain"][edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")] = edge:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
					end
					
					return t
				end
			end
		-- end
	end
	return nil
end

function next_elem_group2 (edge, element, linkName, typeNr,  isSubSelect)
	local baseSelectTable = next_elem2(edge, element, linkName, typeNr,  isSubSelect)
	if baseSelectTable ~= nil then
		if typeNr == 1 then
			-- local name = edge:find(linkName .. "/compartment:has(/compartType[id = 'Instance'])"):attr("value")
			local name = idTable[edge:find(linkName):id()]
			if name == "" or name == nil then name = edge:find(linkName .. "/compartment:has(/compartType[id = 'Name'])"):attr("value") end
			baseSelectTable[name]["linkType"] = "OPTIONAL"
		elseif typeNr == 2 then
			-- local name = edge:find(linkName .. "/compartment:has(/compartType[id = 'Instance'])"):attr("value")
			local name = idTable[edge:find(linkName):id()]
			if name == "" or name == nil then name = edge:find(linkName .. "/compartment:has(/compartType[id = 'Name'])"):attr("value") end
			baseSelectTable[name]["linkType"] = "FILTER NOT EXISTS"
		end
	end
	return baseSelectTable
end

function attributes2 (element, elemName, attributesNamesTable)
	local selection = {}
	local selectionAggr = {}
	local selectionBIND = {}
	local notAggregateAttrList = ""
	local notAggregateAttrListMainSelect = {}
	local attrListDistinct = {}
	local attrListGroupBy = ""
	local aggregateAttrList = ""
	local attrListSubSelection = {}
	local attributesInAggregation = ""
	if element:attr("vq_URISelected") == 'true' then
		attrList = attrList .. "?" .. elemName
	end
	
	local aggr = false
	
	local sp = require "sparql_grammar"
	element:find("/compartment:has(/compartType[id = 'ASFictitiousAttributes'])"):find("/subCompartment:has(/compartType[id = 'Attributes'])"): each(
	function (attr)
		local attrName = attr:find("/subCompartment:has(/compartType[id = 'AttrName'])"):attr("value") 
		if attrName~=nil and attrName~="" then
			
			diagram = utilities.current_diagram()

			--find central class
			local startClass = diagram:find(collection .. "/element:has(/elemType[id = 'Class'])"):filter(function(class)
				return class:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query" and class:find("/container"):is_empty()
			end)
			
			local isAggregate
			local triplesSameSubjectTable = {}
			-- local attrURI2 = lQuery("Onto#Attribute[name='" .. attrName .. "']"):attr("URI")
			local attrURI = getURI("Onto#Attribute", attrName)
			if attrURI == nil or attrURI == "" then attrURI = getURI("Onto#AllAssociation", attrName) end
			attrName, isAggregate, triplesSameSubjectTable, classTriplesTable, isFunction, attributesNamesTable, triplesString, prefixes = sp.parsesparqlExpressionGrammar2(attrName, elemName, nil,  attributesNamesTable, attributesNamesTablePrevious, idTable, element)
			
			for key, value in pairs(prefixes) do
				prefixTable[key] = value
			end
			
			if isFunction==true then isFunctionGlobal = true end
			
			-- print("attrName = ", attrName)
			-- print("isAggregate = ", isAggregate)
			-- print("---------------------")
			-- print("triplesSameSubjectTable = ", dumptable(triplesSameSubjectTable))
			-- print("---------------------")
			-- print("classTriplesTable = ", dumptable(classTriplesTable))
			-- print("isFunction = ", isFunction)
			-- print("attributesNamesTable = ", dumptable(attributesNamesTable))
			table.insert(selection, triplesString)
			-- print("triplesString triplesString triplesString = ", triplesString)
			
			local attrURIShort = ""

			
			if string.find(attrName, ":")~= nil and string.find(attrName, "%(") == nil then
				attrURIShort = string.sub(attrName, 1, string.find(attrName, ":"))
				attrName = "?" .. string.sub(attrName, string.find(attrName, ":")+1)
				if lQuery("Onto#Prefix[shortForm='" .. attrURIShort .. "']"):is_not_empty() then
					prefixTable[attrURIShort] = lQuery("Onto#Prefix[shortForm='" .. attrURIShort .. "']"):attr("fullForm")
				end
			end

			local alias = attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value")
			if alias == "" or alias == nil then alias = attrName 
			else
				alias = "?" .. alias
			end
				
			-- local optional = attr:find("/subCompartment:has(/compartType[id = 'optional'])"):attr("value")
			local optional = attr:find("/subCompartment:has(/compartType[id = 'IsOptional'])"):attr("value")
			local nott = attr:find("/subCompartment:has(/compartType[id = 'IsNegation'])"):attr("value")
			local group = attr:find("/subCompartment:has(/compartType[id = 'IsGroup'])"):attr("value")
			if attrName == nil then
				attrName = ""
			end
			
			if attrURIShort~="" then attrURI = attrURIShort .. string.sub(attrName, 2) end
			
			if attrURI == nil then
				attrURI = ""
			end
			--if this attribute is aggregate function then select it as aggragete
			-- local show = attr:find("/subCompartment:has(/compartType[id = 'Show'])"):attr("value")
			local show = attr:find("/subCompartment:has(/compartType[id = 'Stereotype'])"):attr("value")
			if isAggregate ~= true then
				if isFunction~= true then
					if show == nil or show == "" or show == "show" then
						-- notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " " .. alias
						notAggregateAttrListMainSelect[alias] = alias
						notAggregateAttrList = notAggregateAttrList .. " " ..  alias
						-- attrListDistinct = attrListDistinct .. " " .. alias
						attrListDistinct[alias] = alias
						attrListGroupBy = attrListGroupBy .. " " .. alias
					elseif show == "find" then
						notAggregateAttrList = notAggregateAttrList .. " " ..  alias
						-- attrListDistinct = attrListDistinct .. " " .. alias
						attrListDistinct[alias] = alias
						attrListGroupBy = attrListGroupBy .. " " .. alias
					elseif show == "all" then
						-- attrListDistinct = attrListDistinct .. " " .. alias
						attrListDistinct[alias] = alias
					elseif show == "exists" then
						-- notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " " .. alias
						notAggregateAttrListMainSelect[alias] = alias
						notAggregateAttrList = notAggregateAttrList .. " " ..  alias
						attrListGroupBy = attrListGroupBy .. " " .. alias
					end
					
					-- notAggregateAttrList = notAggregateAttrList .. " " ..  alias 
					-- if show == nil or show == "" or show == "show" then notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " " .. alias end
					--check if this is optional or required
					local attributeTriple = ""
					if optional == 'true' or optional == '{optional} ' then
						attributeTriple = "OPTIONAL { ?" .. elemName .. " " .. attrURI .. " " .. alias .. ".}\n"
					elseif nott == 'true' or nott == "{not} " then
						attributeTriple = "FILTER NOT EXISTS { ?" .. elemName .. " " .. attrURI .. " " .. alias .. ".}\n"
					else
						if attrURI~="" then attributeTriple = "?" .. elemName .. " " .. attrURI .. " " .. alias .. ".\n" end
					end
					
					if group == "true" then
						attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " " .. alias .. " WHERE{\n" .. attributeTriple .. "} GROUP BY ?" .. idTable[startClass:id()] .. " " .. alias .. "}\n" 
					end
					
					if attributeTriple~="" then table.insert(selection, attributeTriple) end
				else
					local aggr = false
					if aggregateGlobal == true then aggr = true end
					if element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "count" or element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "count distinct" then
						aggr = true
					end
					-- if show == nil or show == "" or show == "show" then aggregateAttrList = aggregateAttrList .. " " .. alias end
					-- attrListSubSelection = attrListSubSelection .. " (" .. attrName .. " as " .. alias .. ")"
					local a = "?expr"
					local toolType = lQuery("ToolType")
					a = a .. "_" .. toolType:find("/tag[key = 'counter']"):attr("value")
					
					local notAggregateAttrListMainSelectString
					local attrListDistinctString
					local attrListSubSelectionString = ""
					local attrListSubSelectionAliasString = ""
					local attrListGroupByString = ""
					
					if attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") ~= "true" then 
						-- print("111")
						notAggregateAttrListMainSelectString = "(" .. attrName .. " as " .. alias .. ")"
						if aggr == true then notAggregateAttrListMainSelectString = alias end
						attrListDistinctString = " (" .. attrName .. " as " .. alias .. ")"
						attrListSubSelectionString = " (" .. attrName .. " as " .. alias .. ")"
						attrListSubSelectionAliasString = alias
						attrListGroupByString =  alias
					elseif (attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") == nil or attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") == "") and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") ~= "true" then 
						-- print("222")
						notAggregateAttrListMainSelectString = "(" .. attrName .. " as " .. a .. ")"
						if aggr == true then notAggregateAttrListMainSelectString = a end
						attrListDistinctString = " (" .. attrName .. " as " .. a .. ")"
						attrListSubSelectionString = " (" .. attrName .. " as " .. a .. ")"
						attrListSubSelectionAliasString = a 
						attrListGroupByString =   a
					elseif attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") == "true" then 
						-- print("333")
						table.insert(selectionBIND, "BIND(" .. attrName .. " as " .. alias .. ")\n")
						notAggregateAttrListMainSelectString = "?" .. attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value")
						attrListDistinctString = alias
						attrListSubSelectionString =  alias
						attrListSubSelectionAliasString = alias
						attrListGroupByString =  alias
					elseif (attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") == nil or attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") == "") and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") == "true" then 
						-- print("444")
						table.insert(selectionBIND, "BIND(" .. attrName .. " as " .. a .. ")\n")
						notAggregateAttrListMainSelectString = a
						attrListDistinctString = a
						attrListSubSelectionString = a
						attrListSubSelectionAliasString = a
						attrListGroupByString = a
					else 
						-- print("555")
						notAggregateAttrListMainSelectString = alias
						attrListDistinctString = alias
						attrListSubSelectionString =   " (" .. attrName .. " as " .. alias .. ")"
						attrListSubSelectionAliasString = alias
						attrListGroupByString =  alias
					end
					if show == nil or show == "" or show == "show" then
						notAggregateAttrListMainSelect[notAggregateAttrListMainSelectString] = notAggregateAttrListMainSelectString
						attrListDistinct[attrListDistinctString] = attrListDistinctString
						attrListSubSelection[attrListSubSelectionString] = attrListSubSelectionAliasString
						attrListGroupBy = attrListGroupBy .. " " .. attrListGroupByString
						-- notAggregateAttrList = notAggregateAttrList .. " " ..  alias
					elseif show == "find" then
						-- notAggregateAttrList = notAggregateAttrList .. " " ..  alias
						attrListDistinct[alias] = alias
						-- attrListGroupBy = attrListGroupBy .. " " .. alias
						attrListGroupBy = attrListGroupBy .. " " .. attrListGroupByString
					elseif show == "all" then
						-- attrListDistinct = attrListDistinct .. " " .. alias
						attrListDistinct[alias] = alias
					elseif show == "exists" then
						notAggregateAttrListMainSelect[notAggregateAttrListMainSelectString] = notAggregateAttrListMainSelectString
						-- notAggregateAttrList = notAggregateAttrList .. " (" .. attrName .. " as " .. alias .. ")"
						-- attrListGroupBy = attrListGroupBy .. " " .. alias
						attrListGroupBy = attrListGroupBy .. " " .. attrListGroupByString
					end
					
					attributeTriple = ""
					
					if group == "true" then
						attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " (" .. attrName .. " as " .. alias .. ") WHERE{\n" .. attributeTriple .. "} GROUP BY ?" .. idTable[startClass:id()] .. "}\n" 
					end
					
					for key, value in pairs(triplesSameSubjectTable) do
						if lQuery("Onto#Attribute[name='" .. key .. "']"):is_not_empty() then
							local val
							if attributesNamesTable["?" .. value["var"]]~= nil then val = attributesNamesTable["?" .. value["var"]]
							else val = "?" .. value["var"] end
							
							attributesInAggregation = attributesInAggregation .. " " .. val
							local uri = getURI("Onto#Attribute", key )
							local attributeTriple = "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n"
							
							if group == "true" then
								local groupSelect = ""
								if attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") ~= "true" then 
									groupSelect = " (" .. attrName .. " as " .. alias .. ")"
								elseif attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" and lQuery("Onto#Parameter[name='Generate BIND clauses for named expressions']"):attr("value") == "true" then 
									-- table.insert(selectionBIND, "BIND(" .. attrName .. " as " .. alias .. ")\n")
									groupSelect =  " ?" .. attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value")
								else groupSelect =  alias end
								attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " " .. groupSelect .. " WHERE{\n" .. attributeTriple .. "} GROUP BY ?" .. idTable[startClass:id()] .. "}\n" 
							end
							if value["class"]~="-" then table.insert(selectionAggr, attributeTriple) end					
						elseif lQuery("Onto#AllAssociation[name='" .. key .. "']"):is_not_empty() then
							local val
							if attributesNamesTable["?" .. value["var"]]~= nil then val = attributesNamesTable["?" .. value["var"]]
							else val = "?" .. value["var"] end
							
							attributesInAggregation = attributesInAggregation .. " " .. val
							local uri = getURI("Onto#AllAssociation", key )
							local attributeTriple = "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n"
							if group == "true" then
								attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " (" .. attrName .. " as " .. alias .. ") WHERE{\n" .. attributeTriple .. "} GROUP BY ?" .. idTable[startClass:id()] .. "}\n" 
							end
							if value["class"]~="-" then table.insert(selectionAggr, attributeTriple) end			
							
						end
					end
				end
			else
				if show == nil or show == "" or show == "show" then
						aggregateAttrList = aggregateAttrList .. " " .. alias
						if group == "true" then
							attrListSubSelection[alias] = alias
						else
							if attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" then
								attrListSubSelection[" (" .. attrName .. " as " .. alias .. ")"] = " (" .. attrName .. " as " .. alias .. ")"
							else
								attrListSubSelection[alias] = alias
							end
						end
						-- attrListDistinct = attrListDistinct .. " " .. alias
						-- attrListGroupBy = attrListGroupBy .. " " .. alias
				elseif show == "exists" then
						aggregateAttrList = aggregateAttrList .. " " .. alias
						if group == "true" then
							attrListSubSelection[alias] = alias
						else
							if attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= nil and attr:find("/subCompartment:has(/compartType[id = 'Alias'])"):attr("value") ~= "" then
								attrListSubSelection[" (" .. attrName .. " as " .. alias .. ")"] = " (" .. attrName .. " as " .. alias .. ")"
							else
								attrListSubSelection[alias] = alias
							end
						end
						-- attrListGroupBy = attrListGroupBy .. " " .. alias
				elseif show == "find" or show == "all" then

				
				end

				-- if show == nil or show == "" or show == "show" then aggregateAttrList = aggregateAttrList .. " " .. alias end
				-- if group == "true" then
					-- attrListSubSelection = attrListSubSelection .. alias
				-- else
					-- attrListSubSelection = attrListSubSelection .. " (" .. attrName .. " as " .. alias .. ")"
				-- end
				for key, value in pairs(triplesSameSubjectTable) do
					if lQuery("Onto#Attribute[name='" .. key .. "']"):is_not_empty() then
						local val
						if attributesNamesTable["?" .. value["var"]]~= nil then val = attributesNamesTable["?" .. value["var"]]
						else val = "?" .. value["var"] end
						
						attributesInAggregation = attributesInAggregation .. " " .. val
						local uri = getURI("Onto#Attribute", key )
						-- table.insert(selectionAggr, "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n")
						local attributeTriple =  "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n"
						if optional == 'true' or optional == '{optional} ' then
								attributeTriple = "OPTIONAL { ?" .. value["class"] .. " " .. uri .. " " .. val .. ".}\n"
						end
						if group == "true" then
							attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " (" .. attrName .. " as " .. alias .. ") WHERE{" .. "?" .. value["class"] .. " " .. uri .. " " .. val .. "." .. "} GROUP BY ?" .. idTable[startClass:id()] .. "}\n" 
						end
						if value["class"]~="-" then table.insert(selectionAggr, attributeTriple) end		
					elseif lQuery("Onto#AllAssociation[name='" .. key .. "']"):is_not_empty() then
						local val
						if attributesNamesTable["?" .. value["var"]]~= nil then val = attributesNamesTable["?" .. value["var"]]
						else val = "?" .. value["var"] end
						
						attributesInAggregation = attributesInAggregation .. " " .. val
						local uri = getURI("Onto#AllAssociation", key )
						-- table.insert(selectionAggr, "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n")
						
						local attributeTriple =  "?" .. value["class"] .. " " .. uri .. " " .. val .. ".\n"
						if optional == 'true' or optional == '{optional} ' then
								attributeTriple = "OPTIONAL { ?" .. value["class"] .. " " .. uri .. " " .. val .. ".}\n"
						end
						if group == "true" then
							attributeTriple = "{SELECT ?" .. idTable[startClass:id()] .. " (" .. attrName .. " as " .. alias .. ") WHERE{\n" .. attributeTriple .. "} GROUP BY ?" .. idTable[startClass:id()] .. "}\n" 
						end
						if value["class"]~="-" then table.insert(selectionAggr, attributeTriple) end		
					end
				end
				for key, value in pairs(classTriplesTable) do
					diagram = utilities.current_diagram()
					-- if diagram:find("/element.Node:has(/compartment:has(/compartType[id='Instance'])[value='" .. key .. "'])"):is_not_empty() then
					local classNotEmpty = nil
					for k,v in pairs(idTable) do
						if v == key then classNotEmpty =  diagram:find("/element.Node"):filter(function(el) return el:id() == tonumber(k) end) break end
					end
					if classNotEmpty ~= nil then
						-- local name = diagram:find("/element.Node:has(/compartment:has(/compartType[id='Instance'])[value='" .. key .. "'])/compartment:has(/compartType[id='Name'])"):attr("value")
						local name = classNotEmpty:find("/compartment:has(/compartType[id='Name'])"):attr("value")
						local uri = getURI("Onto#Class", name )
						if uri~="" and uri~=nil then
							table.insert(selectionAggr, "?" .. key .. " a " .. uri .. ".\n")
						end
					end
				end
				aggregateInQuery = true
				aggregationCount = aggregationCount + 1
				aggr = true
			end
		end
	end)
	
	for key, value in pairs(attributesNamesTable) do
		attributesNamesTablePrevious[key] = value
	end
	
	for key, value in pairs(selectionBIND) do
		table.insert(selectionAggr, value)
	end
	-- print("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
	-- print("selection", dumptable(selection))
	-- print("notAggregateAttrList", dumptable(notAggregateAttrList))
	-- print("attrListSubSelection", dumptable(attrListSubSelection))
	-- print("aggr", dumptable(aggr))
	-- print("aggregateAttrList", dumptable(aggregateAttrList))
	-- print("selectionAggr", dumptable(selectionAggr))
	-- print("attributesInAggregation", dumptable(attributesInAggregation))
	-- print("notAggregateAttrListMainSelect", dumptable(notAggregateAttrListMainSelect))
	-- print("attrListDistinct = ", dumptable(attrListDistinct))
	-- print("attrListGroupBy = ", dumptable(attrListGroupBy))
	-- print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	-- print("")
	
	return selection, notAggregateAttrList, aggr, aggregateAttrList, attrListSubSelection, selectionAggr, attributesInAggregation, notAggregateAttrListMainSelect, attrListDistinct, attrListGroupBy
end

function Count_Substring( s1, s2 )
 local magic =  "[%^%$%(%)%%%.%[%]%*%+%-%?]"
 local percent = function(s)return "%"..s end
    return select( 2, s1:gsub( s2:gsub(magic,percent), "" ) )
end

function joinTables(t1, t2)
   for k,v in pairs(t2) do
		t1[k]=v
   end 
   return t1
end

function filters (element, elemName)
	attributesNamesTable = {}
	local compart = element:find("/compartment:has(/compartType[id = 'ASFictitiousConditions'])")
	local filters = ""
	compart:find("/subCompartment:has(/compartType[id = 'Conditions'])"):each(
		function (conditionCompartment)
			local sp = require "sparql_grammar"
	        if conditionCompartment:attr("value")~=nil and conditionCompartment:attr("value")~= "" then
				-- filter, attributesNamesTableTemp, prefixes = sp.parsesparqlExpressionGrammar(conditionCompartment:attr("value"), element:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), nil, attributesNamesTablePrevious)
				filter, attributesNamesTableTemp, prefixes = sp.parsesparqlExpressionGrammar(conditionCompartment:attr("value"), idTable[element:id()], nil, attributesNamesTablePrevious, idTable, element)
				attributesNamesTable = joinTables(attributesNamesTable, attributesNamesTableTemp)
				if Count_Substring(filter, "{" ) == 1 and Count_Substring(filter, "}"  ) == 1 and string.sub(filter, 1, 1) == "{" then
					filter = string.sub(filter, 2)
					filter = string.sub(filter, 1, string.len(filter)-1)
				end
				filters = filters .. filter  .. "\n"
				for key, value in pairs(prefixes) do
					prefixTable[key] = value
				end
			end
		end
	)
	return filters, attributesNamesTable
end

function check2(elem, element, linkType, isSubSelect)
	local visit = elem:attr("visited")
	if visit == 'true' and linkType == 0 then
		if elem:attr("optional") == element:attr("optional") and elem:attr("negation") == element:attr("negation") then
			return "", "", ""
		else
			checking = false
			return "", "", ""
		end
	elseif visit == 'true' then
		checking = false
		return "", "", ""
	else
		if linkType == 0 then
			elem:attr("optional", element:attr("optional"))
			elem:attr("negation", element:attr("negation"))
		elseif linkType == 1 then
			optionalNr = optionalNr + 1
			elem:attr("optional", optionalNr)
			elem:attr("negation", 0)
		else
			negationNr = negationNr + 1
			elem:attr("optional", 0)
			elem:attr("negation", negationNr)
		end
		return  generateSPARQLnoAggregations(elem, linkType)
	end
end

function generateIds()
	if collection == nil then collection = "" end
	local toolType = lQuery("ToolType")
	if toolType:find("/tag[key = 'counter']"):is_empty() then lQuery.create("Tag", {key = 'counter', value = 0}):link("thing", toolType)
	else toolType:find("/tag[key = 'counter']"):attr("value", 1) end
	diagram = utilities.current_diagram()		
	diagram:find(collection .. "/element.Node:has(/elemType[id='Class'])"):each(function (node)
		if node:find("/compartment:has(/compartType[id='Instance'])"):attr("value")~="" and node:find("/compartment:has(/compartType[id='Instance'])"):attr("value")~=nil then
			idTable[node:id()] = node:find("/compartment:has(/compartType[id='Instance'])"):attr("value")
		else
			local nodeName = node:find("/compartment:has(/compartType[id='Name'])"):attr("value")
			if string.sub(nodeName, 1, 1) == "?" then
				nodeName = "_" .. string.sub(nodeName, 2)
			end
			if string.find(nodeName, ":")~= nil then
				nodeName = string.sub(nodeName, string.find(nodeName, ":")+1)
			end
			if nodeName=="" then nodeName = "_" end
			local counter = ""
			if diagram:find(collection .. "/element.Node:has(/elemType[id='Class'])"):filter(function(class) return class:find("/compartment:has(/compartType[id='Name'])"):attr("value") ==  nodeName end):size() > 1 then
				local foundInIdTable = false
				for key, value in pairs(idTable) do 
					if value == nodeName then
						foundInIdTable = true
						break
					end
				end
				if foundInIdTable == true then 
					counter = "_" .. toolType:find("/tag[key = 'counter']"):attr("value")
					toolType:find("/tag[key = 'counter']"):attr("value", tonumber(toolType:find("/tag[key = 'counter']"):attr("value"))+1)
				end
			end
			
			idTable[node:id()] = nodeName .. counter
			
		end
	end)
	
	for key, value in pairs(idTable) do
		local node = diagram:find(collection .. "/element.Node:has(/elemType[id='Class'])"):filter(function(elem) return elem:id() == tonumber(key) end)
		if node:find("/container"):is_not_empty() and node:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query" then
			local containerName = node:find("/container/compartment:has(/compartType[id='Name'])"):attr("value")
			idTable[node:id()] = diagram:find(collection .. "/element.Node:has(/elemType[id='Class']):has(/compartment:has(/compartType[id='Name'])[value='" .. containerName .. "'])"):find("/compartment:has(/compartType[id='Instance'])"):attr("value")
		end
	end
end

function generate_from_selection()
	diagram = utilities.current_diagram()
	collection = "/collection"
	generate()
end

function generate()
	isFunctionGlobal = false
	aggregateGlobal = false
	idTable = {}
	generateIds()
	
	prefixTable = {}
	if collection == nil then collection = "" end
	transformations.createInstanceNames()
	
	aggregateInQuery = false
	aggregationCount = 0

	--get active diagram
	diagram = utilities.current_diagram()

	diagram:find(collection .. "/element:has(/elemType[id = 'Class'])/compartment/subCompartment:has(/compartType[id = 'Attributes'])"):each(function(attribute)
		local attributeName = string.lower(attribute:find("/subCompartment:has(/compartType[id = 'AttrName'])"):attr("value"))
		local grammar = re.compile([[
			main <- ( {(("sum"/ "count distinct" /"count" / "max" / "min" / "avg" / "group_concat" / "sample") space "(" .*) })
			space <- (" "*)
		]])
		local grammar2 = re.compile([[
			main <- ( {([^A-Za-z0-9_]+ ("sum"/ "count distinct" /"count" / "max" / "min" / "avg" / "group_concat" / "sample") space "(" .*)})
			space <- (" "*)
		]])
		local agr = re.match(attributeName, grammar) or re.find(attributeName, grammar2) or "NOT"
		if agr~= "NOT" then aggregateGlobal = true end
	end)
	-- if diagram:find(collection .. "/element:has(/elemType[id = 'Class'])/compartment:has(/compartType[id = 'Stereotype'])[value = 'count']"):is_not_empty() or
	-- diagram:find(collection .. "/element:has(/elemType[id = 'Class'])/compartment:has(/compartType[id = 'Stereotype'])[value = 'count distinct']"):is_not_empty() or
	-- then aggregateGlobal = then end
	
	local groupInQuery = diagram:find(collection .. "/element.Edge:has(/compartment:has(/compartType[id='IsGroup'])[value='true'])")
	local gpoupsInNamedQuery = diagram:find(collection .. "/element.Node:has(/elemType[id='NamedQuery'])")

	--find central class
	local startClass = diagram:find(collection .. "/element:has(/elemType[id = 'Class'])"):filter(function(class)
	    return class:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query" and class:find("/container"):is_empty()
	end)
	
	if startClass:size() == 0 then
		notSupportedtSPARQL()
		return
	end
	
	diagram:find(collection .. "/element.Node"):each(
		function (node)
			node:attr("visited", 'false')
			node:attr("optional", 0)
			node:attr("negation", 0)
		end
	)
	diagram:find(collection .. "/element.Edge"):each(
		function (edge)
			edge:attr("visited", 'false')
		end
	)
	
	checking = true
	optionalNr = 0
	negationNr = 0
	
	--izveidot vaicajumu bez agregatiem un grupam
	--ar visiem NOT/OPTIONAL, nemot vera nosacijumus uz bultam
	local baseSelect = generateSPARQLnoAggregations(startClass)
	

	-- print(dumptable(baseSelect))
	
	local result = ""
	if aggregateInQuery == false then
		local s, t = createSimpleSPARQL(baseSelect, nil, nil, nil, true)
		local sel, neg = createSimpleSPARQLSelect(baseSelect)
		
		local groups = ""
		
		if groupInQuery:is_not_empty() then
			groups = generateGroupSELECTS(groupInQuery, baseSelect)
		end
		if gpoupsInNamedQuery:is_not_empty() then
			groups = groups .. generateNamedQueryGroupSELECTS(gpoupsInNamedQuery, baseSelect)
		end
		
		-- print(dumptable(baseSelect))
		local isExistsStereotype, groupByExists, isClassWithoutSelAttrib = isExistsStereotypeInQuery(baseSelect)
		local groupBy = ""
		-- print(isExistsStereotype, groupByExists, isClassWithoutSelAttrib)
		-- if isExistsStereotype == true and isClassWithoutSelAttrib == true and lQuery("Onto#Parameter[name='Use simple semantics for non-aggregate queries']"):attr("value") ~= "true" then
		-- if isClassWithoutSelAttrib == true and lQuery("Onto#Parameter[name='Use simple semantics for non-aggregate queries']"):attr("value") ~= "true" then
		if isExistsStereotype == true then
			groupBy = "GROUP BY ?" .. idTable[startClass:id()]  ..  groupByExists
		end
		
		if string.find(t, "%{") == nil and string.find(t, "BIND%(") == nil then t = split(t, "\n") end
		
		-- result = "SELECT " .. sel .. " WHERE {\n" .. split(t, "\n") .. groups .. "}\n" .. groupBy .. "\n"
		result = "SELECT " .. sel .. " WHERE {\n" .. t .. "\n" .. groups .. "}\n" .. groupBy .. "\n"
	else
		diagram:find(collection .. "/element.Node"):each(
			function (node)
				node:attr("visited", 'false')
				node:attr("optional", 0)
				node:attr("negation", 0)
			end
		)
		diagram:find(collection .. "/element.Edge"):each(
			function (edge)
				edge:attr("visited", 'false')
			end
		)
		
		checking = true
		optionalNr = 0
		negationNr = 0
	
		local having = ""
		local sp = require "sparql_grammar"
		startClass:find("/compartment:has(/compartType[id='ASFictitiousHaving'])/subCompartment"):each(function(havingC)
			local expression = havingC:find("/subCompartment:has(/compartType[id='Expression'])"):attr("value")
			if expression~=nil and expression~="" then
				having = having .. " FILTER(" .. sp.parsesparqlExpressionGrammar2(expression, "",nil, {}, attributesNamesTablePrevious, idTable, startClass) .. ")\n"
			end
		end)

		local groups = ""
		
		if groupInQuery:is_not_empty() then
			groups = generateGroupSELECTS(groupInQuery, baseSelect)
		end
		
		if gpoupsInNamedQuery:is_not_empty() then
			groups = groups .. generateNamedQueryGroupSELECTS(gpoupsInNamedQuery, baseSelect)
		end
	
		local s = createSimpleSPARQL(baseSelect)
		
		local t, sSub, notAggregateAttr, subSelectsTable = createSPARQLwithSubSelects(baseSelect, startClass, groups, s)

		local notAggregateAttrTable = splitToTable(notAggregateAttr, " ")

		if aggregationCount>=2 and diagram:find(collection .. "/element.Edge/compartment:has(/compartType[id='IsOptional'])[value='true']"):is_not_empty()  and notAggregateAttrTable~=nil then
			
			local toolType = lQuery("ToolType")
			if toolType:find("/tag[key = 'counter']"):is_empty() then lQuery.create("Tag", {key = 'counter', value = 0}):link("thing", toolType) end
			
			local renameTable = {}
			
			for key, value in pairs(subSelectsTable) do
				if key ~= 1 then
					for key1, value1 in pairs(notAggregateAttrTable) do
						renameTable[value1] = value1 .. "_" .. toolType:find("/tag[key = 'counter']"):attr("value")
						
						value = string.gsub(value, value1 .. " ", value1 .. "_" .. toolType:find("/tag[key = 'counter']"):attr("value") .. " ")
						value = string.gsub(value, value1 .. ".\n", value1 .. "_" .. toolType:find("/tag[key = 'counter']"):attr("value") .. ".\n")
						toolType:find("/tag[key = 'counter']"):attr("value", tonumber(toolType:find("/tag[key = 'counter']"):attr("value"))+1)
					end
					t = t .. value
				else
					t = value
				end
				
			end

			local bound = ""
			for key, value in pairs(renameTable) do
				bound = bound .. "FILTER(" .. key .. " = " .. value .. " || !BOUND(" .. key .. ") && !BOUND(" .. value .. "))\n"
			end
			t = t .. bound
		end 
		
		local selectMainStart = "SELECT" .. s .. sSub .. " WHERE\n{\n"
		local selectMainEnd = "}\n"
		
		if lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: Do not generate outer query level without filters']"):attr("value") == "true" and having == "" and #subSelectsTable == 1 then	
			selectMainStart = ""
			selectMainEnd = "\n"
			t = string.sub(t,2, string.len(t)-2)
		end
		
		
		
		result = selectMainStart .. having .. t .. selectMainEnd
		
		-- print("TTTTTTTTT", t)
		
		--+HAVING
	end
	
	local groupByAttribute = ""--findGroupBy()--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	if groupByAttribute ~= "" then
		if groupBy ~= nil and groupBy ~= "" then
			result = result .. "GROUP BY " .. groupByAttribute .. groupBy .. "\n"
		else
			result = result .. "GROUP BY " .. groupByAttribute .. "\n"
		end
	end
	local allOrderBy = ""
	startClass:find("/compartment:has(/compartType[id='ASFictitiousOrderBy'])/subCompartment"):each(function(orderBy)
	    local orderName = orderBy:find("/subCompartment:has(/compartType[id='Name'])"):attr("value")
		local orderDesc = orderBy:find("/subCompartment:has(/compartType[id='Desc'])"):attr("value")
		local orderByString
		if orderDesc == "true" or orderDesc == "DESC" then orderByString = "DESC(?" .. orderName .. ") "
		else orderByString = "?" .. orderName .. " " end
		allOrderBy = allOrderBy .. orderByString
	end)
	if allOrderBy ~= nil and allOrderBy ~= "" then
			result = result .. "ORDER BY " .. allOrderBy .. "\n"
	end
	
	offset = startClass:find("/compartment:has(/compartType[id='SkipRows'])"):attr("value")
	
	if offset ~= nil and offset ~= "" then
			result = result .. "OFFSET " ..offset .. "\n"
	end
	
	limit = startClass:find("/compartment:has(/compartType[id='ShowRows'])"):attr("value")
	
	if limit ~= nil and limit ~= "" then
		result = result .. "LIMIT " .. limit .. "\n"
	end
	result = string.gsub(result, "%.%?", "%.\n%?")
	result = string.gsub(result, "%)%?", "%)\n%?")
	result = string.gsub(result, "\n\n", "\n")
	
	local prefixes = ""
	for key, value in pairs(prefixTable) do
		prefixes = prefixes .. "PREFIX " .. key .. " <" .. value .. ">\n"
	end
	result = prefixes .. "\n" .. result
	
	if lQuery("Onto#Parameter[name='Input inference']"):attr("value") == "true" and lQuery("Onto#Parameter[name='Input inference']"):attr("input")~= nil and lQuery("Onto#Parameter[name='Input inference']"):attr("input")~="" then
		result = "define input:inference '" .. lQuery("Onto#Parameter[name='Input inference']"):attr("input") .. "'\n" .. result
	end
	
	if lQuery("Onto#Parameter[name='General prefix']"):attr("value") == "true" and lQuery("Onto#Parameter[name='General prefix']"):attr("input")~= nil and lQuery("Onto#Parameter[name='General prefix']"):attr("input")~="" then
		result = "PREFIX " .. lQuery("Onto#Parameter[name='General prefix']"):attr("input") .. "\n" .. result
	end
	
	
	sparql_form (result)
end

local groupStartClass
local gpoupStartClassType

function fundGroupStartClass(baseSelect, classA, classB)
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "name" then
				if value == idTable[classA:id()] then
				-- if value == classA:find("/compartment:has(/compartType[id='Instance'])"):attr("value") then
					groupStartClass = classB
					gpoupStartClassType = "/start"
				end
				-- if value == classB:find("/compartment:has(/compartType[id='Instance'])"):attr("value") then
				if value == idTable[classB:id()] then
					groupStartClass = classA
					gpoupStartClassType = "/end"
				end
			end
			fundGroupStartClass(value, classA, classB)
		end
	end
end

function generateNamedQueryGroupSELECTS(groupInQuery, baseSelect)
	local groups = ""
	groupInQuery:each(function(namedQuery)
	
		--find central class
		startClass = groupInQuery:find("/component:has(/elemType[id = 'Class'])"):filter(function(class)
			return class:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query" 
		end)

		diagram:find(collection .. "/element.Node"):each(
			function (node)
				node:attr("visited", 'false')
				node:attr("optional", 0)
				node:attr("negation", 0)
			end
		)
		diagram:find(collection .. "/element.Edge"):each(
			function (edge)
				edge:attr("visited", 'false')
			end
		)
			
		checking = true
		optionalNr = 0
		negationNr = 0
		
		--izveidot vaicajumu bez agregatiem un grupam
		--ar visiem NOT/OPTIONAL, nemot vera nosacijumus uz bultam
		local baseSelect = generateSPARQLnoAggregations(startClass)
		local result = ""
		if aggregateInQuery == false then
			
			-- local s, t = createSimpleSPARQL(baseSelect, true, startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2), startClass:find(path1.. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])"))
			local s, t = createSimpleSPARQL(baseSelect)
			
			local groupBy = " GROUP BY " .. s
			result = "{SELECT " .. s .. " WHERE {\n" .. t .. "} " .. groupBy .. "}\n"
		else
			diagram:find(collection .. "/element.Node"):each(
				function (node)
					node:attr("visited", 'false')
					node:attr("optional", 0)
					node:attr("negation", 0)
				end
			)
			diagram:find(collection .. "/element.Edge"):each(
				function (edge)
					edge:attr("visited", 'false')
				end
			)
			
			checking = true
			optionalNr = 0
			negationNr = 0
		
			local having = ""
			local sp = require "sparql_grammar"
			startClass:find("/compartment:has(/compartType[id='ASFictitiousHaving'])/subCompartment"):each(function(havingC)
				local expression = havingC:find("/subCompartment:has(/compartType[id='Expression'])"):attr("value")
				having = having .. " FILTER(" .. sp.parsesparqlExpressionGrammar2(expression, "", nil, {}, attributesNamesTablePrevious, idTable, startClass) .. ")\n"
			end)
		
			local s, tt = createSimpleSPARQL(baseSelect)
			
			-- local t, sSub = createSPARQLwithSubSelectsInGroup(baseSelect, startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2), startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])"), gpoupStartClassType)
			local t, sSub = createSPARQLwithSubSelectsNamedQueryGpoup(baseSelect, startClass, "")

			result = t
		end
		
		local groupByAttribute = ""--findGroupBy()--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		if groupByAttribute ~= "" then
			if groupBy ~= nil and groupBy ~= "" then
				result = result .. "GROUP BY " .. groupByAttribute .. groupBy .. "\n"
			else
				result = result .. "GROUP BY " .. groupByAttribute .. "\n"
			end
		end
		local allOrderBy = ""
		startClass:find("/compartment:has(/compartType[id='ASFictitiousOrderBy'])/subCompartment"):each(function(orderBy)
			local orderName = orderBy:find("/subCompartment:has(/compartType[id='Name'])"):attr("value")
			local orderDesc = orderBy:find("/subCompartment:has(/compartType[id='Desc'])"):attr("value")
			local orderByString
			if orderDesc == "true" or orderDesc == "DESC" then orderByString = "DESC(?" .. orderName .. ") "
			else orderByString = "?" .. orderName .. " " end
			allOrderBy = allOrderBy .. orderByString
		end)
		if allOrderBy ~= nil and allOrderBy ~= "" then
				result = result .. "ORDER BY " .. allOrderBy .. "\n"
		end
		
		offset = startClass:find("/compartment:has(/compartType[id='SkipRows'])"):attr("value")
		
		if offset ~= nil and offset ~= "" then
				result = result .. "OFFSET " ..offset .. "\n"
		end
		
		limit = startClass:find("/compartment:has(/compartType[id='ShowRows'])"):attr("value")
		
		if limit ~= nil and limit ~= "" then
				result = result .. "LIMIT " .. limit .. "\n"
		end		
		groups = groups .. result
	end)
	return groups
end

function generateGroupSELECTS(groupInQuery, baseSelect)
	local groups = ""
	groupStartClass = nil
	gpoupStartClassType = nil
	diagram = utilities.current_diagram()
	
	groupInQuery:each(function(link)
		local classA = link:find("/end")
		local classB = link:find("/start")
		fundGroupStartClass(baseSelect, classA, classB)
		local path1, path2 = "", ""
		startClass = groupStartClass
		if gpoupStartClassType == "/end" then 
			path1 = "/eEnd"
			path2 = "/start"
		elseif gpoupStartClassType == "/start" then 
			path1 = "/eStart"
			path2 = "/end"
		end
		
		diagram:find(collection .. "/element.Node"):each(
			function (node)
				node:attr("visited", 'false')
				node:attr("optional", 0)
				node:attr("negation", 0)
			end
		)
		diagram:find(collection .. "/element.Edge"):each(
			function (edge)
				edge:attr("visited", 'false')
			end
		)
		
		checking = true
		optionalNr = 0
		negationNr = 0

		--izveidot vaicajumu bez agregatiem un grupam
		--ar visiem NOT/OPTIONAL, nemot vera nosacijumus uz bultam
		local baseSelect = generateSPARQLnoAggregations(startClass)
		local result = ""
		if aggregateInQuery == false then
			
			local s, t = createSimpleSPARQL(baseSelect, true, startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2), startClass:find(path1.. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])"))
			
			local groupBy = " GROUP BY " .. s
			result = "{SELECT " .. s .. " WHERE {\n" .. t .. "} " .. groupBy .. "}\n"
		else
			diagram:find(collection .. "/element.Node"):each(
				function (node)
					node:attr("visited", 'false')
					node:attr("optional", 0)
					node:attr("negation", 0)
				end
			)
			diagram:find(collection .. "/element.Edge"):each(
				function (edge)
					edge:attr("visited", 'false')
				end
			)
			
			checking = true
			optionalNr = 0
			negationNr = 0
		
			local having = ""
			local sp = require "sparql_grammar"
			startClass:find("/compartment:has(/compartType[id='ASFictitiousHaving'])/subCompartment"):each(function(havingC)
				local expression = havingC:find("/subCompartment:has(/compartType[id='Expression'])"):attr("value")
				having = having .. " FILTER(" .. sp.parsesparqlExpressionGrammar2(expression, "", nil, {}, attributesNamesTablePrevious, idTable, startClass) .. ")\n"
			end)
		
			local s, tt = createSimpleSPARQL(baseSelect)
			
			local t, sSub = createSPARQLwithSubSelectsInGroup(baseSelect, startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2), startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])"), gpoupStartClassType)
			
			result = t
			if result == "" then 
				
				
				result = tt 
				
				local e = ""
				local edge = startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])")
				if lQuery("Onto#AllAssociation[name='" .. edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") .. "']"):is_not_empty() then
					local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
					if edge:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value") == "true" then
						-- e = "?" .. edge:find(gpoupStartClassType .. "/compartment:has(/compartType[id='Instance'])"):attr("value") .. " "  ..uri .. " ?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
						e = "?" .. idTable[edge:find(gpoupStartClassType):id()] .. " "  ..uri .. " ?" ..idTable[startClass:id()] .. ".\n"
					else
						-- e =  "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  ..uri .. " ?" .. edge:find(gpoupStartClassType .. "/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
						e =  "?" .. idTable[startClass:id()]  .. " "  ..uri .. " ?" .. idTable[edge:find(gpoupStartClassType):id()] .. ".\n"
					end
				end
				
				-- result = "{SELECT ?" .. startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2 .. "/compartment:has(/compartType[id='Instance'])"):attr("value") .. s .. " WHERE{\n" ..
				result = "{SELECT ?" .. idTable[startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2):id()] .. s .. " WHERE{\n" ..
				-- tt .. e .. "} GROUP BY ?" .. startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2 .. "/compartment:has(/compartType[id='Instance'])"):attr("value") .. s .."}"
				tt .. e .. "} GROUP BY ?" .. idTable[startClass:find(path1 .. ":has(/compartment:has(/compartType[id='IsGroup'])[value='true'])" .. path2):id()] .. s .."}"
			end
		end
		
		local groupByAttribute = ""--findGroupBy()--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		if groupByAttribute ~= "" then
			if groupBy ~= nil and groupBy ~= "" then
				result = result .. "GROUP BY " .. groupByAttribute .. groupBy .. "\n"
			else
				result = result .. "GROUP BY " .. groupByAttribute .. "\n"
			end
		end
		local allOrderBy = ""
		startClass:find("/compartment:has(/compartType[id='ASFictitiousOrderBy'])/subCompartment"):each(function(orderBy)
			local orderName = orderBy:find("/subCompartment:has(/compartType[id='Name'])"):attr("value")
			local orderDesc = orderBy:find("/subCompartment:has(/compartType[id='Desc'])"):attr("value")
			local orderByString
			if orderDesc == "true" or orderDesc == "DESC" then orderByString = "DESC(?" .. orderName .. ") "
			else orderByString = "?" .. orderName .. " " end
			allOrderBy = allOrderBy .. orderByString
		end)
		if allOrderBy ~= nil and allOrderBy ~= "" then
				result = result .. "ORDER BY " .. allOrderBy .. "\n"
		end
		
		offset = startClass:find("/compartment:has(/compartType[id='SkipRows'])"):attr("value")
		
		if offset ~= nil and offset ~= "" then
				result = result .. "OFFSET " ..offset .. "\n"
		end
		
		limit = startClass:find("/compartment:has(/compartType[id='ShowRows'])"):attr("value")
		
		if limit ~= nil and limit ~= "" then
				result = result .. "LIMIT " .. limit .. "\n"
		end		
		groups = groups .. result
	end)
	
	return groups
end

function createSPARQLwithSubSelectsNamedQueryGpoup(baseSelect, startClass, groups)
	local subQueryLink = ""
	local namedQuery = startClass:find("/container")
		
	local diagram = utilities.current_diagram()
	local namedQueryCorrespondedClass = diagram:find("/element.Node:has(/compartment:has(/compartType[id='Name'])[value='" .. namedQuery:find("/compartment:has(/compartType[id='Name'])"):attr("value") .. "']):has(/elemType[id='Class'])")
	local namedQueryCorrespondedClassName = namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Name'])"):attr("value")
	startClass:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value", namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Stereotype'])"))
	-- startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value", namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"))
	namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value", namedQuery:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value"))
	
	local namedQueryCorrespondedClassConnectedClass
	local namedQueryCorrespondedClassLink = namedQueryCorrespondedClass:find("/eEnd")
	if namedQueryCorrespondedClassLink:is_empty() then 
		namedQueryCorrespondedClassLink = namedQueryCorrespondedClass:find("/eStart") 
		local linkInv = namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value")
		namedQueryCorrespondedClassConnectedClass = namedQueryCorrespondedClassLink:find("/end:has(/compartment:has(/compartType[id='Name'])[value!='" .. namedQueryCorrespondedClassName .. "'])")
		if linkInv ~= "true" then
		    -- subQueryLink = "?" .. namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" .. namedQueryCorrespondedClassConnectedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. "."
			subQueryLink = "?" .. idTable[namedQueryCorrespondedClass:id()] .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" .. idTable[namedQueryCorrespondedClassConnectedClass:id()] .. "."
		else
		    -- subQueryLink = "?" .. namedQueryCorrespondedClassConnectedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" ..  namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value").. "."
		    subQueryLink = "?" .. idTable[namedQueryCorrespondedClassConnectedClass:id()] .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" ..  idTable[namedQueryCorrespondedClass:id()] .. "."
		end
	else
		local linkInv = namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value")
		namedQueryCorrespondedClassConnectedClass = namedQueryCorrespondedClassLink:find("/start:has(/compartment:has(/compartType[id='Name'])[value!='" .. namedQueryCorrespondedClassName .. "'])")
	    if linkInv == "true" then
		    -- subQueryLink = "?" .. namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" .. namedQueryCorrespondedClassConnectedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. "."
		    subQueryLink = "?" .. idTable[namedQueryCorrespondedClass:id()] .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" .. idTable[namedQueryCorrespondedClassConnectedClass:id()] .. "."
		else
		    -- subQueryLink = "?" .. namedQueryCorrespondedClassConnectedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" ..  namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value").. "."
		    subQueryLink = "?" .. idTable[namedQueryCorrespondedClassConnectedClass:id()] .. " " .. getURI("Onto#AllAssociation", namedQueryCorrespondedClassLink:find("/compartment:has(/compartType[id='Name'])"):attr("value")) .. " ?" ..  idTable[namedQueryCorrespondedClass:id()] .. "."
		end
	end

	-- local s, t, subSelect, sSub, notAggregateAttr, subSelectsTable = createSimpleSPARQLBaseForAggregatedClasesInNamedQueryGpoup(baseSelect, baseSelect, groups, startClass, subQueryLink, namedQueryCorrespondedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassConnectedClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"))
	local s, t, subSelect, sSub, notAggregateAttr, subSelectsTable = createSimpleSPARQLBaseForAggregatedClasesInNamedQueryGpoup(baseSelect, baseSelect, groups, startClass, subQueryLink, idTable[namedQueryCorrespondedClass:id()], idTable[namedQueryCorrespondedClassConnectedClass:id()])
	return subSelect, sSub, notAggregateAttr, subSelectsTable
end

function createSPARQLwithSubSelects(baseSelect, startClass, groups, mainSelect)
	local s, t, subSelect, sSub, notAggregateAttr, subSelectsTable = createSimpleSPARQLBaseForAggregatedClases(baseSelect, baseSelect, groups, startClass, mainSelect)
	return subSelect, sSub, notAggregateAttr, subSelectsTable
end

function createSPARQLwithSubSelectsInGroup(baseSelect, startClass, edge, gpoupStartClassType)
	local s, t, subSelect, sSub = createSimpleSPARQLBaseForAggregatedClasesInGroup(baseSelect, baseSelect, startClass, edge, gpoupStartClassType)
	return subSelect, sSub
end

local notAggregateAttr = ""
local subSelectsTable = {}

function createSimpleSPARQLBaseForAggregatedClasesInNamedQueryGpoup(baseSelect, fullbaseSelect, groups, startClass, subQueryLink, namedQueryCorrespondedClassInstance, namedQueryCorrespondedClassConnectedClassInstance)
	-- print(dumptable(baseSelect))

	local selectVariables = ""
	local triples = ""
	local allSubSelects = ""
	local sSub = ""
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "isAggregation" and value == true then
				--base
				local s,t, groupBy2, selectDistinct = createSimpleSPARQLBase(fullbaseSelect, baseSelect["name"])
				--classComponemts
				
				local sa, ta = createSimpleSPARQLBase(baseSelect, "")

				local at = ""
				for k,v in pairs(baseSelect["attributesTriples"]) do
					at = at .. v
				end
				
				if baseSelect["link"] == nil then baseSelect["link"] = "" end
				at =  baseSelect["classTriple"] .. at .. baseSelect["filters"] .. baseSelect["link"]
				
				for k,v in pairs(baseSelect["subSelectAttributes"]) do
					at = at .. "\n" .. v
				end
				
				
				-- s = s .. sa
				for k, v in pairs(sa) do
					s[v] = v
				end
				at = at .. ta .. subQueryLink .. "\n"

				-- notAggregateAttr = notAggregateAttr .. sa
				for k, v in pairs(sa) do
					notAggregateAttr = notAggregateAttr .. v
				end
				
				-- at = string.gsub(at, startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassInstance)
				at = string.gsub(at, idTable[startClass:id()], namedQueryCorrespondedClassInstance)
				-- t = string.gsub(t, startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassInstance)
				t = string.gsub(t, idTable[startClass:id()], namedQueryCorrespondedClassInstance)
				
				-- s = split(s, " ")
				at = split(at, "\n").. "\n"
				
				if baseSelect["linkType"]~=nil and baseSelect["linkType"]~="Link" then
					at = baseSelect["linkType"] .. "{\n" .. at .. "}\n"
				end
				
				local groupBy = ""
				local gr = ""
				for v, k in pairs(groupBy2) do
					if v~="" then gr = gr .. v end
				end
				groupBy2 = gr
				
				-- if s~="" or baseSelect["selectAttributes"]~="" then 
					-- local groupByValue = split(s .. baseSelect["selectAttributes"] ..  "?" .. namedQueryCorrespondedClassConnectedClassInstance, " ")
					local groupByValue = split(groupBy2 ..  " ?" .. namedQueryCorrespondedClassConnectedClassInstance, " ")
					groupBy = " GROUP BY " .. groupByValue .. "\n" 
				-- end

				sSub = sSub .. " " .. baseSelect["aggregateAttributes"]

				local unique = gelUniqueStereotyClasses(fullbaseSelect, "")
				
				local startClassURI = ""
				if startClass:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") ~= "exists" then 
					-- startClassURI = "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") 
					startClassURI = "?" .. idTable[startClass:id()]
				end
				
				local className = ""
				-- if baseSelect["stereotype"] ~= "exists" and baseSelect["stereotype"] ~= "find" then className = " ?" ..  baseSelect["name"] end
				if baseSelect["stereotype"] ~= "exists" then className = " ?" ..  baseSelect["name"] end
				
				startClassURI = split(startClassURI ..  className .. " " .. unique, " ")
				-- startClassURI =  string.gsub(startClassURI, startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassInstance)
				startClassURI =  string.gsub(startClassURI, idTable[startClass:id()], namedQueryCorrespondedClassInstance)
				-- local selectArguments =  s .. " " .. baseSelect["selectAttributes"]
				
				local selectArguments = {}
				for k, v in pairs(s) do
					selectArguments[v] = v
				end
				local selectAttributesTable = splitToTable(baseSelect["selectAttributes"], " ")
				if selectAttributesTable~= nil then
					for k, v in pairs(selectAttributesTable) do
						selectArguments[v] = v
					end
				end
				
				-- selectArguments = split(selectArguments, " ")

				local tripleTable = splitToTable(split(t ..at, "\n"), "\n")
				-- local selectTable = splitToTable(split(selectArguments .. " " ..  startClassURI, " ") .. baseSelect["attributesInAggregation"], " ")
				local selectTable = {}
				for k, v in pairs(selectArguments) do
					selectTable[v] = v
				end
				local startClassURITable = splitToTable(startClassURI, " ")
				if startClassURITable~= nil then
					for k, v in pairs(startClassURITable) do
						selectTable[v] = v
					end
				end
				local attributesInAggregationTable = splitToTable(baseSelect["attributesInAggregation"], " ")
				if attributesInAggregationTable~= nil then
					for k, v in pairs(attributesInAggregationTable) do
						selectTable[v] = v
					end
				end
				
				
				local l = false
				for k, v in pairs(tripleTable) do
					local gramar = [[main <- ([^ ] {" ?" string "."} !.)
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result = re.find(v, gramar)
					
					local gramar2 = [[main <- ({"?" string " a"} )
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result2 = re.find(v, gramar2)
					
					if result~= nil then
						if selectTable["?" .. result]== nil  then 
							l=true
						end
					end
					
					if result2~= nil then
						if selectTable["?" .. result2]== nil  then 
							l=true
						end
					end
					
				end
				
				local selectDistinctStart = ""
				local selectDistinctEnd = ""
				
				local sel = ""
				-- selectDistinct[startClassURI] = startClassURI
				local startClassURITable = splitToTable(startClassURI, " ")
				if startClassURITable~= nil then
					for k, v in pairs(startClassURITable) do
						selectDistinct[v] = v
					end
				end
				-- selectDistinct[baseSelect["attributesInAggregation"]] = split(baseSelect["attributesInAggregation"]," ")
				local attributesInAggregationTable = splitToTable(baseSelect["attributesInAggregation"], " ")
				if attributesInAggregationTable~= nil then
					for k, v in pairs(attributesInAggregationTable) do
						selectDistinct[v] = v
					end
				end
				for k, v in pairs(selectDistinct) do
					sel = sel .. " " .. v	
				end
					
				-- local sel = split(selectDistinct .. " " ..  startClassURI .. baseSelect["attributesInAggregation"], " ")
				-- sel = string.gsub(sel, startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassInstance)
				sel = string.gsub(sel, idTable[startClass:id()], namedQueryCorrespondedClassInstance)
				
				if lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "false" or (lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "true" and l == true) then
					
					
					-- selectDistinctStart = "{SELECT DISTINCT "  .. sel ..  " WHERE{\n"
					selectDistinctStart = "{SELECT DISTINCT "  .. split(sel, " ") ..  " WHERE{\n"
					selectDistinctEnd = "}}"
				elseif isFunction == true then
					selectDistinctStart = "{SELECT "  .. split(sel, " ") .. " WHERE{\n"
					selectDistinctEnd = "}}"
				end
				-- sel = string.gsub(baseSelect["subAttributesTriples"] .. " "  ..  selectArguments, startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value"), namedQueryCorrespondedClassInstance)
				local selectArgumentsString = ""
				for k, v in pairs(selectArguments) do
					selectArgumentsString = selectArgumentsString .. " " .. v
				end
				
				local subAttributesTriples = ""
				for k, v in pairs(baseSelect["subAttributesTriples"]) do
					subAttributesTriples = subAttributesTriples .. " " .. v
				end
				
				sel = string.gsub(subAttributesTriples .. " "  ..  selectArgumentsString, idTable[startClass:id()], namedQueryCorrespondedClassInstance)
				local select = "{SELECT "  .. sel .. " WHERE{\n" ..
				selectDistinctStart .. split(t ..at, "\n") ..  groups ..  selectDistinctEnd .. "}\n" .. groupBy .. "}\n"
		
				table.insert(subSelectsTable, select)
				
				allSubSelects = allSubSelects .. select
			else
				local s,t, select, sS = createSimpleSPARQLBaseForAggregatedClasesInNamedQueryGpoup(value, fullbaseSelect, groups, startClass, subQueryLink, namedQueryCorrespondedClassInstance, namedQueryCorrespondedClassConnectedClassInstance)
				triples = triples .. t
				selectVariables = selectVariables .. s
				allSubSelects = allSubSelects .. select
				sSub = sSub .. sS
			end
		end
	end
	return selectVariables, triples, allSubSelects, sSub, notAggregateAttr, subSelectsTable
end

function createSimpleSPARQLBaseForAggregatedClases(baseSelect, fullbaseSelect, groups, startClass, mainSelect)
	
	-- print(dumptable(fullbaseSelect))
	
	local selectVariables = ""
	local triples = ""
	local allSubSelects = ""
	local sSub = ""
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "isAggregation" and value == true then
				--base
				local s,t, groupBy, selectDistinct = createSimpleSPARQLBase(fullbaseSelect, baseSelect["name"])
				
				--classComponemts
				local sa, ta, g, d = createSimpleSPARQLBase(baseSelect, "")
				
				-- groupBy = split(groupBy .. g , " ")
				for k, v in pairs(d) do
					selectDistinct[v] = v
				end
				for k, v in pairs(g) do
					if v~= "" then groupBy[v] = v end
				end
				-- selectDistinct = split(selectDistinct .. d, " ")
				local at = ""
				for k,v in pairs(baseSelect["attributesTriples"]) do
					at = at .. v
				end
				
				
				if baseSelect["link"] == nil then baseSelect["link"] = "" end
				at =  baseSelect["classTriple"] .. at .. baseSelect["filters"] .. baseSelect["link"]
				
				for k,v in pairs(baseSelect["subSelectAttributes"]) do
					at = at .. "\n" .. v
				end
				
				-- s = s .. sa
				for v, k in pairs(sa) do
					s[v] = v
				end

				at = at .. "\n" .. ta
				
				-- notAggregateAttr = notAggregateAttr .. sa
				for v, k in pairs(sa) do
					notAggregateAttr = notAggregateAttr .. v
				end
				
				-- s = split(s, " ")
				at = split(at, "\n").. "\n"
				if baseSelect["linkType"]~=nil and baseSelect["linkType"]~="Link" then
					at = baseSelect["linkType"] .. "{\n" .. at .. "}\n"
				end

				-- local groupBy = ""
				-- if s~="" or baseSelect["selectAttributes"]~="" then 
					-- local groupByValue = split(s .. baseSelect["selectAttributes"], " ")
					-- groupBy = " GROUP BY " .. groupByValue .. "\n" 
				-- end
				
				local gr = ""
				for v, k in pairs(groupBy) do
					if v~="" then gr = gr .. v end
				end
				groupBy = gr
				if groupBy~="" then groupBy = " GROUP BY " .. groupBy .. "\n" end
				
				sSub = sSub .. " " .. baseSelect["aggregateAttributes"]

				local unique = gelUniqueStereotyClasses(fullbaseSelect, "")
				
				local startClassURI = ""
				if startClass:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") ~= "exists" then 
					-- startClassURI = "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") 
					startClassURI = "?" .. idTable[startClass:id()] 
				end
				
				local className = ""
				if baseSelect["stereotype"] ~= "exists"  then className = " ?" ..  baseSelect["name"] end
				-- if baseSelect["stereotype"] ~= "exists" and baseSelect["stereotype"] ~= "find" then className = " ?" ..  baseSelect["name"] end
				
				startClassURI = split(startClassURI ..  className .. " " .. unique, " ")
				
				
				--[[local mainSelectTable = splitToTable(mainSelect, " ")
				local sTable = splitToTable(s, " ")
				diagram = utilities.current_diagram()
				if sTable~=nil then
					for key, value in pairs(sTable) do
						local inMainSelect = false
						for k,v in pairs(mainSelectTable) do 
							if v==value then 
								inMainSelect = true
								break
							end
						end
						if  findInFullBaseSelect(fullbaseSelect, string.sub(value, 2)) == "true" and inMainSelect == false then
							sTable[value] = nil
						end
						if diagram:find(collection .. "/element:has(/elemType[id='Class'])/compartment/subCompartment/subCompartment:has(/compartType[id='AttrName'])[value = '" .. string.sub(value, 2) .. "']"):is_not_empty()  and inMainSelect == false then
							sTable[value] = nil
						end
					end
					s = ""
					for key, value in pairs(sTable) do
						s = s .. " " .. value
					end
				end
				--]]
				
				-- local selectArguments =  s .. " " .. baseSelect["selectAttributes"]
				
				local selectArguments = {}
				
				for k, v in pairs(s) do 
					selectArguments[v] = v
				end
				local selAttrTable = splitToTable(baseSelect["selectAttributes"], " ")
				if selAttrTable~=nil then
					for k, v in pairs(selAttrTable) do 
						selectArguments[v] = v
					end
				end
				
				
				-- selectArguments = split(selectArguments, " ")
				
				local tripleTable = splitToTable(t ..at, "\n")
				-- local selectTable = splitToTable(split(selectArguments .. " " ..  startClassURI, " ") .. baseSelect["attributesInAggregation"], " ")
				local selectTable = {}
				for k, v in pairs(selectArguments) do
					selectTable[v] = v
				end
				
				local startClassURITable = splitToTable(startClassURI, " ")
				if startClassURITable~=nil then
					for k, v in pairs(startClassURITable) do 
						selectTable[v] = v
					end
				end
				
				local attrInaggrTable = splitToTable(baseSelect["attributesInAggregation"], " ")
				if attrInaggrTable~=nil then
					for k, v in pairs(attrInaggrTable) do 
						selectTable[v] = v
					end
				end
				
				for k, v in pairs(selectTable) do
					if string.sub(k, 1, 1) == " " then 
						selectTable[string.sub(k, 2)] = string.sub(k, 2)
						selectTable[k] = nil
					end
				end
				
				local l = false
				for k, v in pairs(tripleTable) do
					local gramar = [[main <- ([^ ] {" ?" string "."} !.)
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result = re.find(v, gramar)
					
					local gramar2 = [[main <- ({"?" string " a"} )
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result2 = re.find(v, gramar2)
					
					if result~= nil then
						if selectTable["?" .. result]== nil  then 
							l=true
						end
					end
					
					if result2~= nil then
						if selectTable["?" .. result2]== nil  then 
							l=true
						end
					end
					
				end
				
				local selectDistinctStart = ""
				local selectDistinctEnd = ""
				
				local sel = ""
					-- selectDistinct[startClassURI] = startClassURI
					local startClassURITable = splitToTable(startClassURI, " ")
					if startClassURITable~= nil then
						for k, v in pairs(startClassURITable) do
							selectDistinct[v] = v
						end
					end
					-- selectDistinct[baseSelect["attributesInAggregation"]] = split(baseSelect["attributesInAggregation"]," ")
					local attributesInAggregationTable = splitToTable(baseSelect["attributesInAggregation"], " ")
					if attributesInAggregationTable~= nil then
						for k, v in pairs(attributesInAggregationTable) do
							selectDistinct[v] = v
						end
					end
					for k, v in pairs(selectDistinct) do
						sel = sel .. " " .. v	
					end
				
				if lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "false" or (lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "true" and l == true) then  
					selectDistinctStart = "{SELECT DISTINCT "  .. sel .. " WHERE{\n"
					selectDistinctEnd = "}}"
				elseif isFunction == true then
					selectDistinctStart = "{SELECT "  .. sel .. " WHERE{\n"
					selectDistinctEnd = "}}"
				end
				
				local mainSelectTable = splitToTable(mainSelect, " ")
				-- local sTable = splitToTable(selectArguments, " ")
				local sTable = {}
				for k, v in pairs(selectArguments) do
					sTable[v] = v
				end

				for k, v in pairs(sTable) do
					if string.sub(k, 1, 1) == " " then 
						sTable[string.sub(k, 2)] = string.sub(k, 2)
						sTable[k] = nil
					end
				end
				-- print("fullbaseSelect", dumptable(fullbaseSelect))
				diagram = utilities.current_diagram()
				if sTable~=nil then
					for key, value in pairs(sTable) do
						local inMainSelect = false
						if mainSelectTable~=nil then
							for k,v in pairs(mainSelectTable) do 
								if v==value then 
									inMainSelect = true
									break
								end
							end
						end
						
						if  findInFullBaseSelect(fullbaseSelect, string.sub(value, 2)) == "true" and inMainSelect == false then
							sTable[value] = nil
						end
						if diagram:find(collection .. "/element:has(/elemType[id='Class'])/compartment/subCompartment/subCompartment:has(/compartType[id='AttrName'])[value = '" .. string.sub(value, 2) .. "']"):is_not_empty()  and inMainSelect == false then
							sTable[value] = nil
						end
					end
					selectArguments = ""
					for key, value in pairs(sTable) do
						selectArguments = selectArguments .. " " .. value
					end
				end
				
				local tat = t ..at
				if string.find(t ..at, "%{") == nil then tat = split(tat, "\n") end
				
				local subAttributesTriples = ""
				if lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "false" or (lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "true" and l == true) or isFunction == true then  
					for k, v in pairs(baseSelect["subAttributesTriples"]) do
						subAttributesTriples = subAttributesTriples .. v
					end
				else
					for k, v in pairs(baseSelect["subAttributesTriples"]) do
						subAttributesTriples = subAttributesTriples .. k
					end
				end

				local select = "{SELECT "  .. subAttributesTriples .. " "  ..  selectArguments .. " WHERE{\n" ..
				selectDistinctStart ..
				tat ..  "\n" .. groups ..  selectDistinctEnd .. "}\n" .. groupBy .. "}\n"
	

				table.insert(subSelectsTable, select)
				
				allSubSelects = allSubSelects .. select
			else
				local s,t, select, sS = createSimpleSPARQLBaseForAggregatedClases(value, fullbaseSelect, groups, startClass, mainSelect)
				triples = triples .. t
				selectVariables = selectVariables .. s
				allSubSelects = allSubSelects .. select
				sSub = sSub .. sS
			end
		end
	end
	return selectVariables, triples, allSubSelects, sSub, notAggregateAttr, subSelectsTable
end

function findInFullBaseSelect(baseSelect, selectValue)
	local isFindClass = ""
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "stereotype" and value == "find" and baseSelect["name"] == selectValue then
				isFindClass = isFindClass .. "true"
			end
			isFindClass = isFindClass ..findInFullBaseSelect(value, selectValue)
		end
	end
	return isFindClass
end

function gelUniqueStereotyClasses(baseSelect)
	local unique = ""
	if type(baseSelect) == "table" then
	for key, value in pairs(baseSelect) do
		if baseSelect["linkType"] ~= "FILTER NOT EXISTS" then
			if key == "stereotype" and value == "all" then
				unique = unique .. " ?" .. baseSelect["name"]
			end
			local u = gelUniqueStereotyClasses(value)
			unique = unique .. u .. " "
		end
	end
	end
	return unique
end

function splitToTable(s, sep)
	local del = sep
	sep=lpeg.P(sep)
	local elem = lpeg.C((1-sep)^0)
	local p = lpeg.Ct(elem * (sep * elem)^0)
	local r = lpeg.match(p,s)
	
	local t
	for key, value in pairs(r) do
		if value~="" then 
			if t == nil then t = {} end
			t[value] = value 
		end
	end

	return t
end

function split(s, sep)
	local del = sep
	sep=lpeg.P(sep)
	local elem = lpeg.C((1-sep)^0)
	local p = lpeg.Ct(elem * (sep * elem)^0)
	local r = lpeg.match(p,s)
	
	local t = {}
	local returnString2 = ""
	for key, value in pairs(r) do
		if t[value] == nil then
			if value~=nil and value~="" and value~=del then
				if returnString2 == "" then returnString2 = value
			else returnString2 = returnString2 .. del .. value end
			end
			t[value] = value
		end
	end
	
	-- local returnString = ""
	
	-- for key, value in pairs(t) do
		-- if t[value]~=nil and t[value]~= "" and t[value]~=del then
			-- if returnString == "" then returnString = t[value]
			-- else returnString = returnString .. del .. t[value] end
		-- end
	-- end
	
	return returnString2
end

function createSimpleSPARQLBaseForAggregatedClasesInGroup(baseSelect, fullbaseSelect, startClass, edge, gpoupStartClassType)
	local selectVariables = ""
	local triples = ""
	local allSubSelects = ""
	local sSub = ""
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "isAggregation" and value == true then
				--base
				local s,t, groupBy, selectDistinct = createSimpleSPARQLBase(fullbaseSelect, baseSelect["name"])
				--classComponemts
				local sa, ta, g, d = createSimpleSPARQLBase(baseSelect, "")
				
				-- groupBy = split(groupBy .. g , " ")
				for k, v in pairs(d) do
					selectDistinct[v] = v
				end
				for k, v in pairs(g) do
					if v~= "" then groupBy[v] = v end
				end
				-- selectDistinct = split(selectDistinct .. d, " ")
				local at = ""
				for k,v in pairs(baseSelect["attributesTriples"]) do
					at = at .. v
				end
				
				if baseSelect["link"] == nil then baseSelect["link"] = "" end
				at =  baseSelect["classTriple"] .. at .. baseSelect["filters"] .. baseSelect["link"]
				
				for k,v in pairs(baseSelect["subSelectAttributes"]) do
					at = at .. "\n" .. v
				end
				
				-- s = s .. sa
				for k, v in pairs(sa) do
					s[v] = v
				end
				at = at .. "\n" .. ta
				
				-- notAggregateAttr = notAggregateAttr .. sa
				for v, k in pairs(sa) do
					notAggregateAttr = notAggregateAttr .. v
				end

				-- s = split(s, " ")
				at = split(at, "\n") .. "\n"
				
				if baseSelect["linkType"]~=nil and baseSelect["linkType"]~="Link" then
					at = baseSelect["linkType"] .. "{\n" .. at .. "}\n"
				end
				
				-- local groupBy = " GROUP BY ?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. s .. baseSelect["selectAttributes"] .. "\n" 
				-- local groupBy = " GROUP BY ?" .. idTable[startClass:id()] .. s .. baseSelect["selectAttributes"] .. "\n" 
				local gr = ""
				for v, k in pairs(groupBy) do
					if v~="" then gr = gr .. v end
				end
				groupBy = gr
				if groupBy~="" then groupBy = " GROUP BY ?" .. idTable[startClass:id()] .. groupBy .. "\n" end
				sSub = sSub .. " " .. baseSelect["aggregateAttributes"]

				local e = ""
				if lQuery("Onto#AllAssociation[name='" .. edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") .. "']"):is_not_empty() then
					local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
					if gpoupStartClassType == "/end" then
						if edge:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value") == "true" then
							-- e = "?" .. edge:find(gpoupStartClassType.."/compartment:has(/compartType[id='Instance'])"):attr("value") .. " "  .. uri .. " ?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
							e = "?" .. idTable[edge:find(gpoupStartClassType):id()] .. " "  .. uri .. " ?" .. idTable[startClass:id()] .. ".\n"
						else
							-- e =  "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" .. edge:find(gpoupStartClassType.."/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
							e =  "?" .. idTable[startClass:id()]  .. " "  .. uri .. " ?" .. idTable[edge:find(gpoupStartClassType):id()] .. ".\n"
						end
					else
						if edge:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value") == "true" then
							-- e =  "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" .. edge:find(gpoupStartClassType.."/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
							e =  "?" .. idTable[startClass:id()]  .. " "  .. uri .. " ?" .. idTable[edge:find(gpoupStartClassType):id()] .. ".\n"
						else
							-- e = "?" .. edge:find(gpoupStartClassType.."/compartment:has(/compartType[id='Instance'])"):attr("value") .. " "  .. uri .. " ?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
							e = "?" .. idTable[edge:find(gpoupStartClassType):id()] .. " "  .. uri .. " ?" .. idTable[startClass:id()] .. ".\n"
						end
					end
				end
				
				local unique = gelUniqueStereotyClasses(fullbaseSelect, "")
				
				local startClassURI = ""
				if startClass:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") ~= "exists" then 
					-- startClassURI = "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") 
					startClassURI = "?" .. idTable[startClass:id()] 
				end
				
				local className = ""
				-- if baseSelect["stereotype"] ~= "exists" and baseSelect["stereotype"] ~= "find" then className = " ?" ..  baseSelect["name"] end
				if baseSelect["stereotype"] ~= "exists"  then className = " ?" ..  baseSelect["name"] end
				
				startClassURI = split(startClassURI ..  className .. " " .. unique, " ")
				-- local selectArguments =  s .. " " .. baseSelect["selectAttributes"]
				
				local selectArguments = {}
				
				for k, v in pairs(s) do
					selectArguments[v] = v
				end
				local selectAttributesTable = splitToTable(baseSelect["selectAttributes"], " ")
				if selectAttributesTable~= nil then
					for k, v in pairs(selectAttributesTable) do
						selectArguments[v] = v
					end
				end
				-- selectArguments = split(selectArguments, " ")

				local tripleTable = splitToTable(split(t ..at, "\n"), "\n")
				-- local selectTable = splitToTable(split(selectArguments .. " " ..  startClassURI, " ") .. baseSelect["attributesInAggregation"], " ")

				local selectTable = {}
				for k, v in pairs(selectArguments) do
					selectTable[v] = v
				end
				
				local startClassURITable = splitToTable(startClassURI, " ")
				if startClassURITable~= nil then
					for k, v in pairs(startClassURITable) do
						selectTable[v] = v
					end
				end
				
				local attributesInAggregationTable = splitToTable(baseSelect["attributesInAggregation"], " ")
				if attributesInAggregationTable~= nil then
					for k, v in pairs(attributesInAggregationTable) do
						selectTable[v] = v
					end
				end
				
				for k, v in pairs(selectTable) do
					if string.sub(k, 1, 1) == " " then 
						selectTable[string.sub(k, 2)] = string.sub(k, 2)
						selectTable[k] = nil
					end
				end
				
				local l = false
				for k, v in pairs(tripleTable) do
					local gramar = [[main <- ([^ ] {" ?" string "."} !.)
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result = re.find(v, gramar)
					
					local gramar2 = [[main <- ({"?" string " a"} )
					string <- ({[A-Za-z0-9_] [A-Za-z0-9_]*})]]
					local _, _ , result2 = re.find(v, gramar2)
					
					if result~= nil then
						if selectTable["?" .. result]== nil  then 
							l=true
						end
					end
					
					if result2~= nil then
						if selectTable["?" .. result2]== nil  then 
							l=true
						end
					end
					
				end
				
				local selectDistinctStrart = ""
				local selectDistinctEnd = ""
				
				
					local sel = ""
					-- selectDistinct[startClassURI] = startClassURI
					local startClassURITable = splitToTable(startClassURI, " ")
					if startClassURITable~= nil then
						for k, v in pairs(startClassURITable) do
							selectDistinct[v] = v
						end
					end
					-- selectDistinct[baseSelect["attributesInAggregation"]] = split(baseSelect["attributesInAggregation"]," ")
					
					local attributesInAggregationTable = splitToTable(baseSelect["attributesInAggregation"], " ")
					if attributesInAggregationTable~= nil then
						for k, v in pairs(attributesInAggregationTable) do
							selectDistinct[v] = v
						end
					end
					
					for k, v in pairs(selectDistinct) do
						sel = sel .. " " .. v	
					end
					
				if lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "false" or (lQuery("Onto#Parameter[name='Optimize out distinctness list creation, when possible']"):attr("value") == "true" and l == true) then
					-- selectDistinctStrart = "{SELECT DISTINCT "  .. split(selectArguments .. " " ..  startClassURI .. baseSelect["attributesInAggregation"], " ") ..  " WHERE{\n"
					
					
					-- selectDistinctStrart = "{SELECT DISTINCT "  .. split(selectDistinct .. " " ..  startClassURI .. baseSelect["attributesInAggregation"], " ") ..  " WHERE{\n"
					selectDistinctStrart = "{SELECT DISTINCT ?"  ..idTable[startClass:id()] .. sel ..  " WHERE{\n"
					selectDistinctEnd = "}}"
				elseif isFunction == true then
					selectDistinctStart = "{SELECT ?"  ..idTable[startClass:id()] .. sel .. " WHERE{\n"
					selectDistinctEnd = "}}"
				end
				
				-- local select = "{SELECT ?"  .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") ..  baseSelect["subAttributesTriples"] .. " " .. selectArguments .. " WHERE{\n" ..
				local selectArgumentsString = ""
				for k, v in pairs(selectArguments) do
					selectArgumentsString = selectArgumentsString .. " " .. v	
				end
				
				local subAttributesTriples = ""
				for k,v in pairs(baseSelect["subAttributesTriples"]) do
					subAttributesTriples = subAttributesTriples .. " " .. v
				end
				
				local select = "{SELECT ?"  .. idTable[startClass:id()] .. subAttributesTriples .. " " .. selectArgumentsString .. " WHERE{\n" ..
				selectDistinctStrart ..
				split(t ..at .. e, "\n") .. selectDistinctEnd .. "}\n" .. groupBy .. "}\n"
				allSubSelects = allSubSelects .. select
			else
				local s,t, select, sS = createSimpleSPARQLBaseForAggregatedClasesInGroup(value, fullbaseSelect, startClass, edge, gpoupStartClassType)
				triples = triples .. t
				selectVariables = selectVariables .. s
				allSubSelects = allSubSelects .. select
				sSub = sSub .. sS
			end
		end
	end
	return selectVariables, triples, allSubSelects, sSub
end

function createSimpleSPARQLBase(baseSelect, name)

	local selectVariables = {}
	local triples = ""
	local groupBy = {}
	local selectDistinct = {}
	-- print("CLCLCLCLCLCLCLCLCCLCLCLCLCLCLCLCLCLCLCLCL", dumptable(baseSelect["classes"]))
	-- print("ATATATATATATATATATATATATATATATATATATATATA", dumptable(baseSelect["attributesTriples"]))
	for key, value in pairs(baseSelect) do
		if name ~= baseSelect["name"] then
			
			if key == "stereotype" and value == "find" then
				-- selectVariables = selectVariables .. " ?" .. baseSelect["name"]
				selectVariables["?" .. baseSelect["name"]] = "?" .. baseSelect["name"]
				-- groupBy = groupBy .. " ?" .. baseSelect["name"]
				groupBy[" ?" .. baseSelect["name"]] = " ?" .. baseSelect["name"]
			end
			if key == "selectAttributes" then
				-- selectVariables = selectVariables .. " " .. value
				selectVariables[value] = value
			end
			if key == "classTriple" then
			-- if key == "classTriple" and lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "true" and (#baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL") then
			-- if key == "classTriple" and (#baseSelect["classes"]~=0 or (lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "true" and (#baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL"))) then
				-- if baseSelect["linkType"] == "OPTIONAL" then
					-- if  lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "false" then
						-- triples = triples .. value
					-- end
				-- else
				
				-- if #baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL" then
				if table.empty(baseSelect["classes"])~=true or table.empty(baseSelect["attributesTriples"])~=true or baseSelect["linkType"] ~= "OPTIONAL" then	
					triples = triples .. value 
				end
			end
			if key == "attributesTriples" then
				for k, v in pairs(value) do
					triples = triples .. v
				end
			end
			-- if key == "filters" and baseSelect["isAggregation"] == false then
			if key == "filters"  then
			-- if key == "filters" and lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "true" and (#baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL") then
				-- if baseSelect["linkType"] == "OPTIONAL" then
					-- if  lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "false" then
						-- triples = triples .. value
					-- end
				-- else
				-- if #baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL" then
				if table.empty(baseSelect["classes"])~=true or table.empty(baseSelect["attributesTriples"])~=true or baseSelect["linkType"] ~= "OPTIONAL" then
					triples = triples .. value 
				end
			end

			if key == "link" then
			-- if key == "link" and lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "true" and (#baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL") then
				-- if baseSelect["linkType"] == "OPTIONAL" then
					-- if  lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "false" then
						-- triples = triples .. value
					-- end
				-- else
				-- if #baseSelect["classes"]~=0 or #baseSelect["attributesTriples"]~=0 or baseSelect["linkType"] ~= "OPTIONAL" then
				if table.empty(baseSelect["classes"])~=true or table.empty(baseSelect["attributesTriples"])~=true or baseSelect["linkType"] ~= "OPTIONAL" then
					triples = triples .. value 
				end
			end
			if key == "conditionLinks" then
				triples = triples .. value
			end
			
			if key == "attrListGroupBy" then
				-- groupBy = groupBy .. value
				groupBy[value] = value
			end
			
			if key == "attrListDistinct" then
				for k, v in pairs(value) do
					selectDistinct[v] = v
				end
				-- selectDistinct = selectDistinct .. value
			end
			
			if key == "classes"  then
				local s, t, g, d = createSimpleSPARQLBaseLinkedClasses(value, name)
				triples = triples .. t .. "\n"
				-- selectVariables = selectVariables .. s
				for k, v in pairs(s) do
					selectVariables[v] = v
				end
				-- groupBy = groupBy .. g
				for k, v in pairs(g) do
					groupBy[v] = v
				end
				for k, v in pairs(d) do
					selectDistinct[v] = v
				end
				-- selectDistinct = selectDistinct .. d
			end
		end
		-- if key == "classes" then
			-- local s, t = createSimpleSPARQLBaseLinkedClasses(value, name)
			-- triples = triples .. t
			-- selectVariables = selectVariables .. s
		-- end
	end
	
	return selectVariables, triples, groupBy, selectDistinct
end
 
function createSimpleSPARQLBaseLinkedClasses(baseSelect, name)
	local triples = ""
	local selectDistinct, groupBy, selectVariables = {}, {}, {}
	for key, value in pairs(baseSelect) do
		for key2, value2 in pairs(value) do
			local s, t,  g, d = createSimpleSPARQLBase(value2, name)
			-- print(dumptable(value2))
			for k, v in pairs(s) do
				if k == "" then s[k] = nil end
			end
			t = split(t, "\n")
			if value2["linkType"]~="Link" and t~="" then
			-- if value2["linkType"]~="Link" and t~="" and value2[""] then
				if value2["linkType"]=="OPTIONAL" and table.empty(s) and lQuery("Onto#Parameter[name='Optimize SPARQL levels, when possible: OPTIONAL groups without variables']"):attr("value") == "true"  then
					t = ""
				else t = value2["linkType"] .. "{\n" .. t .. "}\n" end
			end

			-- selectVariables = selectVariables .. s
			for k, v in pairs(s) do
				selectVariables[v] = v
			end
			triples = triples .. t
			-- groupBy = groupBy .. g
			for k, v in pairs(g) do
				groupBy[v] = v
			end
			-- selectDistinct = selectDistinct .. d
			for k, v in pairs(d) do
				selectDistinct[v] = v
			end
		end
	end
	return selectVariables, triples, groupBy, selectDistinct
end

function isExistsStereotypeInQuery(baseSelect)
	local isExistsStereotype = false
	local isClassWithoutSelAttrib = false
	local groupBy = "" 
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "stereotype" then
				if value == "exists" then 
					isExistsStereotype = true 
				end
			end
			
			-- if key == "selectAttributesMain" and (value == "" or value == nil) then
			if key == "selectAttributesMain" and table.empty(value) then
				isClassWithoutSelAttrib = true
			end
			
			-- if key == "selectAttributesMain" and value ~= nil and value ~= "" then
			if key == "selectAttributesMain" and table.empty(value) == false then
				-- groupBy = groupBy .. " " .. value
				for k, v in pairs(value) do
					if string.find(v, " as ")~= nil then groupBy = groupBy .. " " ..string.sub(v,  string.find(v, " as ")+4, string.len(v)-1)
					else groupBy = groupBy .. " " .. v end
				end
			end
			-- if key == "classes" then
				local s, g, a  = isExistsStereotypeInQuery(value)
				groupBy = groupBy .. g
				if s == true then isExistsStereotype = true end
				if a == true then isClassWithoutSelAttrib = true end
				-- isExistsStereotype = isExistsStereotype .. s
			-- end
			
		end
	end
	return isExistsStereotype, groupBy, isClassWithoutSelAttrib
end

function createSimpleSPARQLSelect(baseSelect, negation)
	local select = "" 
	if type(baseSelect) == "table" then
		for key, value in pairs(baseSelect) do
			if key == "selectAttributesMain" then
				if baseSelect["linkType"]~= "FILTER NOT EXISTS" and negation~=true then
					-- select = select .. " " .. value
					for k, v in pairs(value) do
						select = select .. " " .. v
					end
				elseif baseSelect["linkType"]== "FILTER NOT EXISTS" then
					negation = true
				end
			end
			local s, n = createSimpleSPARQLSelect(value, negation)
			select = select .. s
			if n == true then negation = true end
		end
	end
	return select, negation
end

function createSimpleSPARQL(baseSelect, forGroup, startClass, edge, forMainSelect)
	local selectVariables = ""
	local triples = "" 
	for key, value in pairs(baseSelect) do
		if key == "selectAttributesMain" then
			-- selectVariables = selectVariables .. " " .. value
			for k, v in pairs(value) do
				selectVariables = selectVariables .. " " .. v
			end
		end
		if key == "classTriple" then
			triples = triples .. value
		end
		if key == "attributesTriples" then
			local tv = ""
			for k, v in pairs(value) do
				tv = tv .. v
			end
			triples = triples .. split(tv, "\n") .. "\n"
		end
		if key == "conditionNotLinks" then
			triples = triples .. "FILTER NOT EXISTS{" .. value .. "}\n"
		end
		if key == "filters" then
			triples = triples .. value
		end
		if key == "classes" then
			local s, t = createSimpleSPARQLLinkedClasses(value, forMainSelect)
			triples = triples .. t
			selectVariables = selectVariables .. s
		end
		if key == "link" then
			triples = triples .. value
		end
		if key == "conditionLinks" then
			triples = triples .. value
		end
		if key == "subSelectAttributes" and isFunctionGlobal == true then
			for k, v in pairs(value) do
				triples = triples .. "\n" .. v
			end
		end
	end
	
	if forGroup~=nil then
		local e = ""
		if lQuery("Onto#AllAssociation[name='" .. edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") .. "']"):is_not_empty() then
			local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value"))
			if edge:find("/compartment:has(/compartType[id='IsInverse'])"):attr("value") == "true" then
				-- e = "?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value") .. " "  .. uri .. " ?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
				e = "?" .. idTable[edge:find("/end"):id()] .. " "  .. uri .. " ?" .. idTable[startClass:id()] .. ".\n"
			else
				-- e =  "?" .. startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
				e =  "?" .. idTable[startClass:id()]  .. " "  .. uri .. " ?" .. idTable[edge:find("/end"):id()] .. ".\n"
			end
		end
		triples = triples .. e
		
		-- selectVariables = selectVariables .. " ?" ..startClass:find("/compartment:has(/compartType[id='Instance'])"):attr("value")
		selectVariables = selectVariables .. " ?" .. idTable[startClass:id()]
	end

	return selectVariables, triples
end

function createSimpleSPARQLLinkedClasses(baseSelect, forMainSelect)
	local selectVariables, triples = "", ""
	for key, value in pairs(baseSelect) do
		for key2, value2 in pairs(value) do
			local s, t = createSimpleSPARQL(value2, nil, nil, nil, forMainSelect)
			if value2["linkType"]~="Link" then
				t = value2["linkType"] .. "{\n" .. t .. "}\n"
			end
			selectVariables = selectVariables .. s
			triples = triples .. t
		end
	end
	return selectVariables, triples
end



function generateSPARQLnoAggregations(element)
	local selectAttrList, graph_declarations, filters_declarations = "", "", ""
	
	local attributesNamesTable = {}
	
	local baseSelectTable = {}
	
	-- local name = element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
	local name = idTable[element:id()]
	-- local URI = lQuery("Onto#Class[name='" .. element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") .. "']"):first():attr("URI")
	local URI = getURI("Onto#Class", element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value") )
	
	local className = element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
	--do not add class for OWL Thing
	if URI ~= "<http://www.w3.org/2002/07/owl#Thing>" and URI~="" and URI~=nil then
		baseSelectTable["classTriple"] = "?" .. name .. " a " .. URI .. ".\n"
	elseif className and string.sub(className, 1, 1) == "?" then
		baseSelectTable["classTriple"] = "?" .. name .. " a " .. className .. ".\n"
	elseif className~=nil and string.find(className, ":")~=nil then
		local instanceName = element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
		-- if instanceName == nil or instanceName == "" then
			-- instanceName = string.sub(className, string.find(className, ":")+1)
		-- end
		baseSelectTable["classTriple"] = "?" .. name  .. " a " .. className .. ".\n"
		if lQuery("Onto#Prefix[shortForm='" .. string.sub(className,1, string.find(className, ":")) .. "']"):is_not_empty() then
			prefixTable[string.sub(className,1, string.find(className, ":"))] = lQuery("Onto#Prefix[shortForm='" .. string.sub(className,1, string.find(className, ":")) .. "']"):attr("fullForm")
		end
	else
		baseSelectTable["classTriple"] = ""
	end
	
	element:attr("visited", 'true')
	
	baseSelectTable["filters"], attributesNamesTable = filters (element, name)
	local selection, notAggregateAttrList, aggr, aggregateAttrList, attrListSubSelection, selectionAggr, attributesInAggregation, notAggregateAttrListMainSelect, attrListDistinct, attrListGroupBy = attributes2 (element, name, attributesNamesTable)
	
	for k, v in pairs(selectionAggr) do 
		local s = splitToTable(v, "\n")
		if s~=nil then
			for r, p in pairs (s) do
				for n, m in pairs(selection) do
					local t = splitToTable(m, "\n")
					if t ~= nil then 
						for i, j in pairs(t) do
							if p.. "\n" == j then s[r] = nil end
							if j  == p then s[r] = nil end
						end
					end
				end
			end
			local sel = ""
			for r, p in pairs (s) do
				sel  = sel .. p
			end
			selectionAggr[k] = sel
		end
	end
	
	if element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "select" then
		notAggregateAttrList = notAggregateAttrList .. " ?" ..  name
		-- notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " ?" ..  name
		notAggregateAttrListMainSelect["?" ..  name] = "?" ..  name
		attrListGroupBy = attrListGroupBy .. " ?" ..  name
	end
	
	if element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")~=nil and string.sub(element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value"), 1, 1) == "?" then
		-- notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " " .. element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
		-- notAggregateAttrListMainSelect = notAggregateAttrListMainSelect .. " ?" ..  name
		-- notAggregateAttrListMainSelect["?" ..  name] = "?" ..  name
		notAggregateAttrListMainSelect["?" ..  name] = element:find("/compartment:has(/compartType[id = 'Name'])"):attr("value")
	end
	
	--if (element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "find") then name = "" end
	
	baseSelectTable["name"] = name
	baseSelectTable["selectAttributes"] = notAggregateAttrList
	baseSelectTable["selectAttributesMain"] = notAggregateAttrListMainSelect
	baseSelectTable["attributesTriples"] = selection
	baseSelectTable["isAggregation"] = aggr
	baseSelectTable["subSelectAttributes"] = selectionAggr
	baseSelectTable["aggregateAttributes"] = aggregateAttrList
	baseSelectTable["subAttributesTriples"] = attrListSubSelection
	baseSelectTable["attributesInAggregation"] = attributesInAggregation
	baseSelectTable["attrListDistinct"] = attrListDistinct
	baseSelectTable["attrListGroupBy"] = attrListGroupBy
	baseSelectTable["classes"] = {}
	baseSelectTable["stereotype"] = element:find("/compartment:has(/compartType[id = 'Stereotype'])"):attr("value")
	
	diagram = utilities.current_diagram()
	local className = element:find("/compartment:has(/compartType[id='Name'])"):attr("value")
	
	if (element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "count" and diagram:find(collection .. "/element:has(/elemType[id='NamedQuery']):has(/compartment:has(/compartType[id='Name'])[value='" .. className .. "'])"):is_empty() or
	element:find("/container"):is_not_empty() and element:find("/container/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "count") then 
		aggregateInQuery = true
		aggregationCount = aggregationCount + 1
		baseSelectTable["isAggregation"] = true
		-- baseSelectTable["subAttributesTriples"] = baseSelectTable["subAttributesTriples"] .. " (COUNT(?" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value") .. ") as ?count_of_" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value") .. ") "
		-- baseSelectTable["subAttributesTriples"] = baseSelectTable["subAttributesTriples"] .. " (COUNT(?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "
		baseSelectTable["subAttributesTriples"][" (COUNT(?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "] = " (COUNT(?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "
		-- baseSelectTable["aggregateAttributes"] = baseSelectTable["aggregateAttributes"] .. " ?count_of_" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
		baseSelectTable["aggregateAttributes"] = baseSelectTable["aggregateAttributes"] .. " ?count_of_" .. idTable[element:id()]
	end
	
	if element:find("/compartment:has(/compartType[id='Stereotype'])"):attr("value") == "count distinct" and  diagram:find(collection .. "/element:has(/elemType[id='NamedQuery']):has(/compartment:has(/compartType[id='Name'])[value='" .. className .. "'])"):is_empty() then
		aggregateInQuery = true
		aggregationCount = aggregationCount + 1
		baseSelectTable["isAggregation"] = true
		-- baseSelectTable["subAttributesTriples"] = baseSelectTable["subAttributesTriples"] .. " (COUNT (DISTINCT ?" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value") .. ") as ?count_of_" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value") .. ") "
		-- baseSelectTable["subAttributesTriples"] = baseSelectTable["subAttributesTriples"] .. " (COUNT (DISTINCT ?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "
		baseSelectTable["subAttributesTriples"][" (COUNT (DISTINCT ?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "] = " (COUNT (DISTINCT ?" .. idTable[element:id()] .. ") as ?count_of_" .. idTable[element:id()] .. ") "
		-- baseSelectTable["aggregateAttributes"] = baseSelectTable["aggregateAttributes"] .. " ?count_of_" .. element:find("/compartment:has(/compartType[id = 'Instance'])"):attr("value")
		baseSelectTable["aggregateAttributes"] = baseSelectTable["aggregateAttributes"] .. " ?count_of_" .. idTable[element:id()]
	end

	if diagram:find(collection .. "/element:has(/elemType[id='NamedQuery']):has(/compartment:has(/compartType[id='Name'])[value='" .. className .. "'])"):is_not_empty() then baseSelectTable["isAggregation"] = false end
	
	if element:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query"
	and lQuery("Onto#Parameter[name='Default main class instance to the grouping set also in presence of aggregated attributes for it']"):attr("value") == "true" 
	and (element:find("/compartment:has(/compartType[id = 'Stereotype'])"):is_empty() or element:find("/compartment:has(/compartType[id = 'Stereotype'])"):attr("value") == "") then
		baseSelectTable["stereotype"] = "find"
	elseif element:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") == "query" 
	and baseSelectTable["isAggregation"] ~= true 
	and (element:find("/compartment:has(/compartType[id = 'Stereotype'])"):is_empty() or element:find("/compartment:has(/compartType[id = 'Stereotype'])"):attr("value") == "") then
		if lQuery("Onto#Parameter[name='Include non-aggregated main class instance into grouping set by default (implicit use of <<find>>-stereotype)']"):attr("value") == "true" then
			baseSelectTable["stereotype"] = "find"
		else
			baseSelectTable["stereotype"] = "all"
		end
	elseif aggregateGlobal == true 
	  and (element:find("/compartment:has(/compartType[id = 'Stereotype'])"):is_empty() 
	  or element:find("/compartment:has(/compartType[id = 'Stereotype'])"):attr("value") == "") 
	  and element:find("/compartment/subCompartment:has(/compartType[id = 'Attributes'])"):is_empty()
	  then
	    baseSelectTable["stereotype"] = "exists"
	elseif baseSelectTable["isAggregation"] ~= true and (element:find("/compartment:has(/compartType[id = 'Stereotype'])"):is_empty() or element:find("/compartment:has(/compartType[id = 'Stereotype'])"):attr("value") == "") then
		if lQuery("Onto#Parameter[name='Use simple semantics for non-aggregate queries']"):attr("value") == "true" then
			baseSelectTable["stereotype"] = "find"
		-- elseif element:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") ~= "query" and element:find("/compartment/subCompartment:has(/compartType[id='Attributes'])/subCompartment:has(/compartType[id='Stereotype'])[value='find']"):size() == 0 and baseSelectTable["selectAttributesMain"] == "" then
		elseif element:find("/compartment:has(/compartType[id='ClassType'])"):attr("value") ~= "query" and element:find("/compartment/subCompartment:has(/compartType[id='Attributes'])/subCompartment:has(/compartType[id='Stereotype'])[value='find']"):size() == 0 and table.empty(baseSelectTable["selectAttributesMain"]) then
			baseSelectTable["stereotype"] = "exists"
		else
			baseSelectTable["stereotype"] = "find"
		end
	end
	
	element:find("/eStart:has(/elemType[id = 'Link' ])"):filter(function(edge)
	    return edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")~="true"
		and edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true" 
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem2(edge, element, "/end", 0))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem2(edge, element, "/end", 0))
		end
	end)
	element:find("/eEnd:has(/elemType[id = 'Link' ])"):filter(function(edge)
	    return edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")~="true"
		and edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true" 
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem2(edge, element, "/start", 0))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem2(edge, element, "/start", 0))
		end
	end)
	
	element:find("/eStart:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/end", 1))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/end", 1))
		end
	end)
	
	element:find("/eEnd:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/start", 1))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/start", 1))
		end	
	end)
	
	element:find("/eStart:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/end", 2))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/end", 2))
		end	
	end)
	
	element:find("/eEnd:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if collection~="" then 
			if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
				table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/start", 2))
			end
		else
			table.insert(baseSelectTable["classes"], next_elem_group2(edge, element, "/start", 2))
		end	
	end)
	
	element:find("/eStart:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if edge:attr("visited")~= "true" then
			edge:attr("visited", 'true')
			local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
			if collection~="" then 
				if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
					local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
					if inv == "true" then
						--baseSelectTable["conditionNotLinks"] = " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  ..uri .. " ?" ..name  .. ".\n"
						baseSelectTable["conditionNotLinks"] = " ?" .. idTable[edge:find("/end"):id()] .. " "  ..uri .. " ?" ..name  .. ".\n"
					else
						baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. idTable[edge:find("/end"):id()]   .. ".\n"
					end
				end
			else
				local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
				if inv == "true" then
					-- baseSelectTable["conditionNotLinks"] = " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" ..name  .. ".\n"
					baseSelectTable["conditionNotLinks"] = " ?" .. idTable[edge:find("/end"):id()]  .. " "  .. uri .. " ?" ..name  .. ".\n"
				else
					-- baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
					baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. idTable[edge:find("/end"):id()] .. ".\n"
				end
			end			
		end
	end)
	
	element:find("/eEnd:has(/elemType[id = 'Link'])"):filter(function(edge)
	    return  edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true"
	end):each(function (edge)
		if edge:attr("visited")~= "true" then
			edge:attr("visited", 'true')	
			local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
			if collection~="" then 
				if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
					local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
					if inv == "true" then
						baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. idTable[edge:find("/start"):id()] .. ".\n"
						-- baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
					else
						-- baseSelectTable["conditionNotLinks"] = " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" ..name  .. ".\n"
						baseSelectTable["conditionNotLinks"] = " ?" .. idTable[edge:find("/start"):id()]  .. " "  .. uri .. " ?" ..name  .. ".\n"
					end
				end
			else
				local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
				if inv == "true" then
					-- baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value") .. ".\n"
					baseSelectTable["conditionNotLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. idTable[edge:find("/start"):id()] .. ".\n"
				else
					-- baseSelectTable["conditionNotLinks"] = " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" ..name  .. ".\n"
					baseSelectTable["conditionNotLinks"] = " ?" .. idTable[edge:find("/start"):id()]  .. " "  .. uri .. " ?" ..name  .. ".\n"
				end
			end			
		end
	end)
	
	-- parastais link + cndition
	element:find("/eStart:has(/elemType[id = 'Link' ])"):filter(function(edge)
	    return edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")~="true"
		and edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true" 
	end):each(function (edge)
		if edge:attr("visited")~= "true" then
			edge:attr("visited", 'true')
			local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
			if collection~="" then 
				if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
					local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
					if inv == "true" then
						-- baseSelectTable["conditionLinks"] = " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  ..uri .. " ?" ..name .. ".\n"
						baseSelectTable["conditionLinks"] = " ?" .. idTable[edge:find("/end"):id()] .. " "  ..uri .. " ?" ..name .. ".\n"
					else
						-- baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value").. ".\n"
						baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. idTable[edge:find("/end"):id()].. ".\n"
					end
				end
			else
				local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
				if inv == "true" then
					-- baseSelectTable["conditionLinks"] = " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" ..name .. ".\n"
					baseSelectTable["conditionLinks"] = " ?" .. idTable[edge:find("/end"):id()]  .. " "  .. uri .. " ?" ..name .. ".\n"
				else
					-- baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. edge:find("/end/compartment:has(/compartType[id='Instance'])"):attr("value").. ".\n"
					baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  .. uri .. " ?" .. idTable[edge:find("/end"):id()].. ".\n"
				end
			end		
		end
	end)
	
	element:find("/eEnd:has(/elemType[id = 'Link'])"):filter(function(edge)
		return edge:find("/compartment:has(/compartType[id = 'IsCondition'])"):attr("value")=="true" and edge:find("/compartment:has(/compartType[id = 'IsNegation'])"):attr("value")~="true"
		and edge:find("/compartment:has(/compartType[id = 'IsOptional'])"):attr("value")~="true" and edge:find("/compartment:has(/compartType[id = 'IsGroup'])"):attr("value")~="true" 
	end):each(function (edge)
		if edge:attr("visited")~= "true" then
			edge:attr("visited", 'true')		
			local uri = getURI("Onto#AllAssociation", edge:find("/compartment:has(/compartType[id='Name'])"):attr("value") )
			if collection~="" then 
				if diagram:find("/collection/element"):filter(function(elem) return elem:id() == edge:id() end):is_not_empty() then
					local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
					if inv == "true" then
						-- baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value").. ".\n"
						baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. idTable[edge:find("/start"):id()].. ".\n"
					else
						-- baseSelectTable["conditionLinks"] = " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value")  .. " "  .. uri .. " ?" ..name .. ".\n"
						baseSelectTable["conditionLinks"] = " ?" .. idTable[edge:find("/start"):id()]  .. " "  .. uri .. " ?" ..name .. ".\n"
					end
				end
			else
				local inv = edge:find("/compartment:has(/compartType[id = 'IsInverse'])"):attr("value")
				if inv == "true" then
					-- baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. edge:find("/start/compartment:has(/compartType[id='Instance'])"):attr("value").. ".\n"
					baseSelectTable["conditionLinks"] = " ?" ..  name .. " "  ..uri .. " ?" .. idTable[edge:find("/start"):id()] .. ".\n"
				else
					baseSelectTable["conditionLinks"] = " ?" .. idTable[edge:find("/start"):id()]  .. " "  .. uri .. " ?" ..name .. ".\n"
				end
			end		
		end
	end)
	
	return baseSelectTable
end

function table.empty (self)
    for _, _ in pairs(self) do
        return false
    end
    return true
end


function sparql_form(result)
	--print("start")

	--get active diagram
	--diagram = utilities.current_diagram()

	formAttributes =
		{caption = "Generated SPARQL",
		id = "generatedSPARQL",
		--will call event Close when X clicked at the top of the form
		buttonClickOnClose = false,
		--add that elements will be righ aligned
		--horizontalAlignment = 1,
		minimumWidth = 500,
		minimumHeight = 300
		}

	--Use utilities library to add and display form also auto delete form at end
	form = dialog.add_form (formAttributes)
		--add event handler that will close form when X clicked at the form top
		dialog.add_event_handlers(form, {Close = "lua.generate_SPARQL.closeForm"})

	add_component("D#TextArea", {id = "GeneratedQuery", text = result}, form)
	horizontal1 = add_component ("D#HorizontalBox", {horizontalAlignment = 1}, form)
	saveButton = add_component("D#Button", {caption = "Save to file"}, horizontal1)
	dialog.add_event_handlers(saveButton, {Click = "lua.generate_SPARQL.saveToText"})
	saveButton = add_component("D#Button", {caption = "Close"}, horizontal1)
	dialog.add_event_handlers(saveButton, {Click = "lua.generate_SPARQL.closeForm"})
	dialog.show_form(form)

	local file = assert(io.open("query.txt", "w+"))
	file:write(result)
	file:close()
end

function closeForm ()
	tda.HideInformationBar()
	--lQuery("D#Form[id='generatedSPARQL']"):link("command", function() return utilities.execute_cmd("D#Command", {info = "Close"}) end)
	dialog.close_form("generatedSPARQL")
end

function add_component(component_type, attributes, container)
	if container ~= nil then
		return lQuery.create(component_type, attributes):link("container", container)
	else
		return lQuery.create(component_type, attributes)
	end
end